GNU GRUB manual
***************

This is the documentation of GNU GRUB, the GRand Unified Bootloader, a
flexible and powerful boot loader program for a wide range of
architectures.

   This edition documents version 2.13.

   This manual is for GNU GRUB (version 2.13, 9 May 2025).

   Copyright ©
1999,2000,2001,2002,2004,2006,2008,2009,2010,2011,2012,2013 Free
Software Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.2 or any later version published by the Free Software
     Foundation; with no Invariant Sections.

1 Introduction to GRUB
**********************

1.1 Overview
============

Briefly, a “boot loader” is the first software program that runs when a
computer starts.  It is responsible for loading and transferring control
to an operating system “kernel” software (such as Linux or GNU Mach).
The kernel, in turn, initializes the rest of the operating system (e.g.
a GNU system).

   GNU GRUB is a very powerful boot loader, which can load a wide
variety of free operating systems, as well as proprietary operating
systems with chain-loading(1) (1).  GRUB is
designed to address the complexity of booting a personal computer; both
the program and this manual are tightly bound to that computer platform,
although porting to other platforms may be addressed in the future.

   One of the important features in GRUB is flexibility; GRUB
understands filesystems and kernel executable formats, so you can load
an arbitrary operating system the way you like, without recording the
physical position of your kernel on the disk.  Thus you can load the
kernel just by specifying its file name and the drive and partition
where the kernel resides.

   When booting with GRUB, you can use either a command-line interface
(see Command-line interface), or a menu interface (see Menu interface).
Using the command-line interface, you type the drive
specification and file name of the kernel manually.  In the menu
interface, you just select an OS using the arrow keys.  The menu is
based on a configuration file which you prepare beforehand (see
Configuration).  While in the menu, you can switch to the command-line
mode, and vice-versa.  You can even edit menu entries before using them.

   In the following chapters, you will learn how to specify a drive, a
partition, and a file name (see Naming convention) to GRUB, how to
install GRUB on your drive (see Installation), and how to boot your
OSes (see Booting), step by step.

   (1) “chain-load” is the mechanism for loading unsupported operating
systems by loading another boot loader.  It is typically used for
loading DOS or Windows.

1.2 History of GRUB
===================

GRUB originated in 1995 when Erich Boleyn was trying to boot the GNU
Hurd with the University of Utah's Mach 4 microkernel (now known as GNU
Mach).  Erich and Brian Ford designed the Multiboot Specification (see
Multiboot Specification (multiboot)), because they were determined
not to add to the large number of mutually-incompatible PC boot methods.

   Erich then began modifying the FreeBSD boot loader so that it would
understand Multiboot.  He soon realized that it would be a lot easier to
write his own boot loader from scratch than to keep working on the
FreeBSD boot loader, and so GRUB was born.

   Erich added many features to GRUB, but other priorities prevented him
from keeping up with the demands of its quickly-expanding user base.  In
1999, Gordon Matzigkeit and Yoshinori K. Okuji adopted GRUB as an
official GNU package, and opened its development by making the latest
sources available via anonymous CVS. See Obtaining and Building GRUB,
for more information.

   Over the next few years, GRUB was extended to meet many needs, but it
quickly became clear that its design was not keeping up with the
extensions being made to it, and we reached the point where it was very
difficult to make any further changes without breaking existing
features.  Around 2002, Yoshinori K. Okuji started work on PUPA
(Preliminary Universal Programming Architecture for GNU GRUB), aiming to
rewrite the core of GRUB to make it cleaner, safer, more robust, and
more powerful.  PUPA was eventually renamed to GRUB 2, and the original
version of GRUB was renamed to GRUB Legacy.  Small amounts of
maintenance continued to be done on GRUB Legacy, but the last release
(0.97) was made in 2005 and at the time of writing it seems unlikely
that there will be another.

   By around 2007, GNU/Linux distributions started to use GRUB 2 to
limited extents, and by the end of 2009 multiple major distributions
were installing it by default.

1.3 Differences from previous versions
======================================

GRUB 2 is a rewrite of GRUB (see History), although it shares many
characteristics with the previous version, now known as GRUB Legacy.
Users of GRUB Legacy may need some guidance to find their way around
this new version.

   • The configuration file has a new name (‘grub.cfg’ rather than
     ‘menu.lst’ or ‘grub.conf’), new syntax (see Configuration) and
     many new commands (see Commands).  Configuration cannot be
     copied over directly, although most GRUB Legacy users should not
     find the syntax too surprising.

   • ‘grub.cfg’ is typically automatically generated by ‘grub-mkconfig’
     (see Simple configuration).  This makes it easier to handle
     versioned kernel upgrades.

   • Partition numbers in GRUB device names now start at 1, not 0 (see
     Naming convention).

   • The configuration file is now written in something closer to a full
     scripting language: variables, conditionals, and loops are
     available.

   • A small amount of persistent storage is available across reboots,
     using the ‘save_env’ and ‘load_env’ commands in GRUB and the
     ‘grub-editenv’ utility.  This is not available in all
     configurations (see Environment block).

   • GRUB 2 has more reliable ways to find its own files and those of
     target kernels on multiple-disk systems, and has commands (see
     search) to find devices using file system labels or Universally
     Unique Identifiers (UUIDs).

   • GRUB 2 is available for several other types of system in addition
     to the PC BIOS systems supported by GRUB Legacy: PC EFI, PC
     coreboot, PowerPC, SPARC, and MIPS Lemote Yeeloong are all
     supported.

   • Many more file systems are supported, including but not limited to
     ext4, HFS+, and NTFS.

   • GRUB 2 can read files directly from LVM and RAID devices.

   • A graphical terminal and a graphical menu system are available.

   • GRUB 2's interface can be translated, including menu entry names.

   • The image files (see Images) that make up GRUB have been
     reorganised; Stage 1, Stage 1.5, and Stage 2 are no more.

   • GRUB 2 puts many facilities in dynamically loaded modules, allowing
     the core image to be smaller, and allowing the core image to be
     built in more flexible ways.

1.4 GRUB features
=================

The primary requirement for GRUB is that it be compliant with the
“Multiboot Specification”, which is described in Multiboot Specification (multiboot).

   The other goals, listed in approximate order of importance, are:

   • Basic functions must be straightforward for end-users.

   • Rich functionality to support kernel experts and designers.

   • Backward compatibility for booting FreeBSD, NetBSD, OpenBSD, and
     Linux.  Proprietary kernels (such as DOS, Windows NT, and OS/2) are
     supported via a chain-loading function.

   Except for specific compatibility modes (chain-loading and the Linux
“piggyback” format), all kernels will be started in much the same state
as in the Multiboot Specification.  Only kernels loaded at 1 megabyte or
above are presently supported.  Any attempt to load below that boundary
will simply result in immediate failure and an error message reporting
the problem.

   In addition to the requirements above, GRUB has the following
features (note that the Multiboot Specification doesn't require all the
features that GRUB supports):

Recognize multiple executable formats
     Support many of the “a.out” variants plus “ELF”. Symbol tables are
     also loaded.

Support non-Multiboot kernels
     Support many of the various free 32-bit kernels that lack Multiboot
     compliance (primarily FreeBSD, NetBSD(1) (
     1), OpenBSD, and Linux).  Chain-loading of
     other boot loaders is also supported.

Load multiples modules
     Fully support the Multiboot feature of loading multiple modules.

Load a configuration file
     Support a human-readable text configuration file with preset boot
     commands.  You can also load another configuration file dynamically
     and embed a preset configuration file in a GRUB image file.  The
     list of commands (see Commands) are a superset of those
     supported on the command-line.  An example configuration file is
     provided in Configuration.

Provide a menu interface
     A menu interface listing preset boot commands, with a programmable
     timeout, is available.  There is no fixed limit on the number of
     boot entries, and the current implementation has space for several
     hundred.

Have a flexible command-line interface
     A fairly flexible command-line interface, accessible from the menu,
     is available to edit any preset commands, or write a new boot
     command set from scratch.  If no configuration file is present,
     GRUB drops to the command-line.

     The list of commands (see Commands) are a subset of those
     supported for configuration files.  Editing commands closely
     resembles the Bash command-line (see Bash (features)),
     with <TAB>-completion of commands, devices, partitions,
     and files in a directory depending on context.

Support multiple filesystem types
     Support multiple filesystem types transparently, plus a useful
     explicit blocklist notation.  The currently supported filesystem
     types are “Amiga Fast FileSystem (AFFS)”, “AtheOS fs”, “BeFS”,
     “BtrFS” (including raid0, raid1, raid10, gzip and lzo), “cpio”
     (little- and big-endian bin, odc and newc variants), “EROFS” (only
     uncompressed support for now), “Linux ext2/ext3/ext4”, “DOS
     FAT12/FAT16/FAT32”, “exFAT”, “F2FS”, “HFS”, “HFS+”, “ISO9660”
     (including Joliet, Rock-ridge and multi-chunk files), “JFS”, “Minix
     fs” (versions 1, 2 and 3), “nilfs2”, “NTFS” (including
     compression), “ReiserFS”, “ROMFS”, “Amiga Smart FileSystem (SFS)”,
     “Squash4”, “tar”, “UDF”, “BSD UFS/UFS2”, “XFS”, and “ZFS”
     (including lzjb, gzip, zle, mirror, stripe, raidz1/2/3 and
     encryption in AES-CCM and AES-GCM). See Filesystem, for more
     information.  Note: Only a subset of filesystems are supported in
     lockdown mode (such as when secure boot is enabled, see
     Lockdown for more information).

Support automatic decompression
     Can decompress files which were compressed by ‘gzip’ or ‘xz’(2)
     (2).  This function is both automatic and
     transparent to the user (i.e.  all functions operate upon the
     uncompressed contents of the specified files).  This greatly
     reduces a file size and loading time, a particularly great benefit
     for floppies.(3)  (3)

     It is conceivable that some kernel modules should be loaded in a
     compressed state, so a different module-loading command can be
     specified to avoid uncompressing the modules.

Access data on any installed device
     Support reading data from any or all floppies or hard disk(s)
     recognized by the BIOS, independent of the setting of the root
     device.

Be independent of drive geometry translations
     Unlike many other boot loaders, GRUB makes the particular drive
     translation irrelevant.  A drive installed and running with one
     translation may be converted to another translation without any
     adverse effects or changes in GRUB's configuration.

Detect all installed RAM
     GRUB can generally find all the installed RAM on a PC-compatible
     machine.  It uses an advanced BIOS query technique for finding all
     memory regions.  As described on the Multiboot Specification (see
     Multiboot Specification (multiboot)), not all kernels make use
     of this information, but GRUB provides it for those who do.

Support Logical Block Address mode
     In traditional disk calls (called “CHS mode”), there is a geometry
     translation problem, that is, the BIOS cannot access over 1024
     cylinders, so the accessible space is limited to at least 508 MB
     and to at most 8GB. GRUB can't universally solve this problem, as
     there is no standard interface used in all machines.  However,
     several newer machines have the new interface, Logical Block
     Address (“LBA”) mode.  GRUB automatically detects if LBA mode is
     available and uses it if available.  In LBA mode, GRUB can access
     the entire disk.

Support network booting
     GRUB is basically a disk-based boot loader but also has network
     support.  You can load OS images from a network by using the “TFTP”
     protocol.

Support remote terminals
     To support computers with no console, GRUB provides remote terminal
     support, so that you can control GRUB from a remote host.  Only
     serial terminal support is implemented at the moment.

   (1) The NetBSD/i386 kernel is Multiboot-compliant, but lacks support
for Multiboot modules.

   (2) Only CRC32 data integrity check is supported (xz default is CRC64
so one should use -check=crc32 option).  LZMA BCJ filters are supported.

   (3) There are a few pathological cases where loading a very badly
organized ELF kernel might take longer, but in practice this never
happen.

1.5 The role of a boot loader
=============================

The following is a quotation from Gordon Matzigkeit, a GRUB fanatic:

     Some people like to acknowledge both the operating system and
     kernel when they talk about their computers, so they might say they
     use "GNU/Linux" or "GNU/Hurd".  Other people seem to think that the
     kernel is the most important part of the system, so they like to
     call their GNU operating systems "Linux systems."

     I, personally, believe that this is a grave injustice, because the
     _boot loader_ is the most important software of all.  I used to
     refer to the above systems as either "LILO"(1) (1)
     or "GRUB" systems.

     Unfortunately, nobody ever understood what I was talking about; now
     I just use the word "GNU" as a pseudonym for GRUB.

     So, if you ever hear people talking about their alleged "GNU"
     systems, remember that they are actually paying homage to the best
     boot loader around... GRUB!

   We, the GRUB maintainers, do not (usually) encourage Gordon's level
of fanaticism, but it helps to remember that boot loaders deserve
recognition.  We hope that you enjoy using GNU GRUB as much as we did
writing it.

   (1) The LInux LOader, a boot loader that everybody uses, but nobody
likes.

2 Naming convention
*******************

The device syntax used in GRUB is a wee bit different from what you may
have seen before in your operating system(s), and you need to know it so
that you can specify a drive/partition.

   Look at the following examples and explanations:

     (fd0)

   First of all, GRUB requires that the device name be enclosed with ‘(’
and ‘)’.  The ‘fd’ part means that it is a floppy disk.  The number ‘0’
is the drive number, which is counted from _zero_.  This expression
means that GRUB will use the whole floppy disk.

     (hd0,msdos2)

   Here, ‘hd’ means it is a hard disk drive.  The first integer ‘0’
indicates the drive number, that is, the first hard disk, the string
‘msdos’ indicates the partition scheme, while the second integer, ‘2’,
indicates the partition number (or the PC slice number in the BSD
terminology).  The partition numbers are counted from _one_, not from
zero (as was the case in previous versions of GRUB). This expression
means the second partition of the first hard disk drive.  In this case,
GRUB uses one partition of the disk, instead of the whole disk.

     (hd0,msdos5)

   This specifies the first “extended partition” of the first hard disk
drive.  Note that the partition numbers for extended partitions are
counted from ‘5’, regardless of the actual number of primary partitions
on your hard disk.

     (hd1,msdos1,bsd1)

   This means the BSD ‘a’ partition on first PC slice number of the
second hard disk.

   Of course, to actually access the disks or partitions with GRUB, you
need to use the device specification in a command, like ‘set root=(fd0)’
or ‘parttool (hd0,msdos3) hidden-’.  To help you find out which number
specifies a partition you want, the GRUB command-line (see
Command-line interface) options have argument completion.  This means
that, for example, you only need to type

     set root=(

   followed by a <TAB>, and GRUB will display the list of drives,
partitions, or file names.  So it should be quite easy to determine the
name of your target partition, even with minimal knowledge of the
syntax.

   Note that GRUB does _not_ distinguish IDE from SCSI - it simply
counts the drive numbers from zero, regardless of their type.  Normally,
any IDE drive number is less than any SCSI drive number, although that
is not true if you change the boot sequence by swapping IDE and SCSI
drives in your BIOS.

   Now the question is, how to specify a file?  Again, consider an
example:

     (hd0,msdos1)/vmlinuz

   This specifies the file named ‘vmlinuz’, found on the first partition
of the first hard disk drive.  Note that the argument completion works
with file names, too.

   That was easy, admit it.  Now read the next chapter, to find out how
to actually install GRUB on your drive.

3 OS-specific notes about grub tools
************************************

On OS which have device nodes similar to Unix-like OS GRUB tools use the
OS name.  E.g.  for GNU/Linux:

     # grub-install /dev/sda

   On AROS we use another syntax.  For volumes:

     //:<volume name>

   E.g.

     //:DH0

   For disks we use syntax:
     //:<driver name>/unit/flags

   E.g.

     # grub-install //:ata.device/0/0

   On Windows we use UNC path.  For volumes it's typically

     \\?\Volume{<GUID>}
     \\?\<drive letter>:

   E.g.

     \\?\Volume{17f34d50-cf64-4b02-800e-51d79c3aa2ff}
     \\?\C:

   For disks it's

     \\?\PhysicalDrive<number>

   E.g.

     # grub-install \\?\PhysicalDrive0

   Beware that you may need to further escape the backslashes depending
on your shell.

   When compiled with cygwin support then cygwin drive names are
automatically when needed.  E.g.

     # grub-install /dev/sda

4 Installation
**************

In order to install GRUB as your boot loader, you need to first install
the GRUB system and utilities under your UNIX-like operating system
(see Obtaining and Building GRUB).  You can do this either from the
source tarball, or as a package for your OS.

   After you have done that, you need to install the boot loader on a
drive (floppy or hard disk) by using the utility ‘grub-install’ (see
Invoking grub-install) on a UNIX-like OS.

   GRUB comes with boot images, which are normally put in the directory
‘/usr/lib/grub/<cpu>-<platform>’ (for BIOS-based machines
‘/usr/lib/grub/i386-pc’).  Hereafter, the directory where GRUB images
are initially placed (normally ‘/usr/lib/grub/<cpu>-<platform>’) will be
called the “image directory”, and the directory where the boot loader
needs to find them (usually ‘/boot’) will be called the “boot
directory”.

4.1 Installing GRUB using grub-install
======================================

For information on where GRUB should be installed on PC BIOS platforms,
see BIOS installation.

   In order to install GRUB under a UNIX-like OS (such as GNU), invoke
the program ‘grub-install’ (see Invoking grub-install) as the
superuser (“root”).

   The usage is basically very simple.  You only need to specify one
argument to the program, namely, where to install the boot loader.  The
argument has to be either a device file (like ‘/dev/hda’).  For example,
under Linux the following will install GRUB into the MBR of the first
IDE disk:

     # grub-install /dev/sda

   Likewise, under GNU/Hurd, this has the same effect:

     # grub-install /dev/hd0

   But all the above examples assume that GRUB should put images under
the ‘/boot’ directory.  If you want GRUB to put images under a directory
other than ‘/boot’, you need to specify the option ‘--boot-directory’.
The typical usage is that you create a GRUB boot floppy with a
filesystem.  Here is an example:

     # mke2fs /dev/fd0
     # mount -t ext2 /dev/fd0 /mnt
     # mkdir /mnt/boot
     # grub-install --boot-directory=/mnt/boot /dev/fd0
     # umount /mnt

   Some BIOSes have a bug of exposing the first partition of a USB drive
as a floppy instead of exposing the USB drive as a hard disk (they call
it "USB-FDD" boot).  In such cases, you need to install like this:

     # losetup /dev/loop0 /dev/sdb1
     # mount /dev/loop0 /mnt/usb
     # grub-install --boot-directory=/mnt/usb/bugbios --force --allow-floppy /dev/loop0

   This install doesn't conflict with standard install as long as they
are in separate directories.

   On EFI systems for fixed disk install you have to mount EFI System
Partition.  If you mount it at ‘/boot/efi’ then you don't need any
special arguments:

     # grub-install

   Otherwise you need to specify where your EFI System partition is
mounted:

     # grub-install --efi-directory=/mnt/efi

   For removable installs you have to use ‘--removable’ and specify both
‘--boot-directory’ and ‘--efi-directory’:

     # grub-install --efi-directory=/mnt/usb --boot-directory=/mnt/usb/boot --removable

4.2 Making a GRUB bootable CD-ROM
=================================

GRUB supports the “no emulation mode” in the El Torito specification(1)
(1).  This means that you
can use the whole CD-ROM from GRUB and you don't have to make a floppy
or hard disk image file, which can cause compatibility problems.

   For booting from a CD-ROM, GRUB uses a special image called
‘cdboot.img’, which is concatenated with ‘core.img’.  The ‘core.img’
used for this should be built with at least the ‘iso9660’ and ‘biosdisk’
modules.  Your bootable CD-ROM will usually also need to include a
configuration file ‘grub.cfg’ and some other GRUB modules.

   To make a simple generic GRUB rescue CD, you can use the
‘grub-mkrescue’ program (see Invoking grub-mkrescue):

     $ grub-mkrescue -o grub.iso

   You will often need to include other files in your image.  To do
this, first make a top directory for the bootable image, say, ‘iso’:

     $ mkdir iso

   Make a directory for GRUB:

     $ mkdir -p iso/boot/grub

   If desired, make the config file ‘grub.cfg’ under ‘iso/boot/grub’
(see Configuration), and copy any files and directories for the disc
to the directory ‘iso/’.

   Finally, make the image:

     $ grub-mkrescue -o grub.iso iso

   This produces a file named ‘grub.iso’, which then can be burned into
a CD (or a DVD), or written to a USB mass storage device.

   The root device will be set up appropriately on entering your
‘grub.cfg’ configuration file, so you can refer to file names on the CD
without needing to use an explicit device name.  This makes it easier to
produce rescue images that will work on both optical drives and USB mass
storage devices.

   (1) El Torito is a specification for bootable CD using BIOS
functions.

4.3 The map between BIOS drives and OS devices
==============================================

If the device map file exists, the GRUB utilities (‘grub-probe’, etc.)
read it to map BIOS drives to OS devices.  This file consists of lines
like this:

     (DEVICE) FILE

   DEVICE is a drive specified in the GRUB syntax (see Device syntax),
and FILE is an OS file, which is normally a device file.

   Historically, the device map file was used because GRUB device names
had to be used in the configuration file, and they were derived from
BIOS drive numbers.  The map between BIOS drives and OS devices cannot
always be guessed correctly: for example, GRUB will get the order wrong
if you exchange the boot sequence between IDE and SCSI in your BIOS.

   Unfortunately, even OS device names are not always stable.  Modern
versions of the Linux kernel may probe drives in a different order from
boot to boot, and the prefix (‘/dev/hd*’ versus ‘/dev/sd*’) may change
depending on the driver subsystem in use.  As a result, the device map
file required frequent editing on some systems.

   GRUB avoids this problem nowadays by using UUIDs or file system
labels when generating ‘grub.cfg’, and we advise that you do the same
for any custom menu entries you write.  If the device map file does not
exist, then the GRUB utilities will assume a temporary device map on the
fly.  This is often good enough, particularly in the common case of
single-disk systems.

   However, the device map file is not entirely obsolete yet, and it is
used for overriding when current environment is different from the one
on boot.  Most common case is if you use a partition or logical volume
as a disk for virtual machine.  You can put any comments in the file if
needed, as the GRUB utilities assume that a line is just a comment if
the first character is ‘#’.

4.4 BIOS installation
=====================

MBR
===

The partition table format traditionally used on PC BIOS platforms is
called the Master Boot Record (MBR) format; this is the format that
allows up to four primary partitions and additional logical partitions.
With this partition table format, there are two ways to install GRUB: it
can be embedded in the area between the MBR and the first partition
(called by various names, such as the "boot track", "MBR gap", or
"embedding area", and which is usually at least 1000 KiB), or the core
image can be installed in a file system and a list of the blocks that
make it up can be stored in the first sector of that partition.

   Modern tools usually leave MBR gap of at least 1023 KiB. This amount
is sufficient to cover most configurations.  Hence this value is
recommended by the GRUB team.

   Historically many tools left only 31 KiB of space.  This is not
enough to parse reliably difficult structures like Btrfs, ZFS, RAID or
LVM, or to use difficult disk access methods like ahci.  Hence GRUB will
warn if attempted to install into small MBR gap except in a small number
of configurations that were grandfathered.  The grandfathered config
must:

   • use biosdisk as disk access module for ‘/boot’

   • not use any additional partition maps to access ‘/boot’

   • ‘/boot’ must be on one of following filesystems: AFFS, AFS, BFS,
     cpio, newc, odc, ext2/3/4, FAT, exFAT, F2FS, HFS, uncompressed
     HFS+, ISO9660, JFS, Minix, Minix2, Minix3, NILFS2, NTFS, ReiserFS,
     ROMFS, SFS, tar, UDF, UFS1, UFS2, XFS
   Note: Only a subset of filesystems are supported in lockdown mode
(such as when secure boot is enabled, see Lockdown for more
information).

   MBR gap has few technical problems.  There is no way to reserve space
in the embedding area with complete safety, and some proprietary
software is known to use it to make it difficult for users to work
around licensing restrictions.  GRUB works around it by detecting
sectors by other software and avoiding them and protecting its own
sectors using Reed-Solomon encoding.

   GRUB team recommends having MBR gap of at least 1000 KiB.

   Should it not be possible, GRUB has support for a fallback solution
which is heavily recommended against.  Installing to a filesystem means
that GRUB is vulnerable to its blocks being moved around by filesystem
features such as tail packing, or even by aggressive fsck
implementations, so this approach is quite fragile; and this approach
can only be used if the ‘/boot’ filesystem is on the same disk that the
BIOS boots from, so that GRUB does not have to rely on guessing BIOS
drive numbers.

   The GRUB development team generally recommends embedding GRUB before
the first partition, unless you have special requirements.  You must
ensure that the first partition starts at least 1000 KiB (2000 sectors)
from the start of the disk; on modern disks, it is often a performance
advantage to align partitions on larger boundaries anyway, so the first
partition might start 1 MiB from the start of the disk.

GPT
===

Some newer systems use the GUID Partition Table (GPT) format.  This was
specified as part of the Extensible Firmware Interface (EFI), but it can
also be used on BIOS platforms if system software supports it; for
example, GRUB and GNU/Linux can be used in this configuration.  With
this format, it is possible to reserve a whole partition for GRUB,
called the BIOS Boot Partition.  GRUB can then be embedded into that
partition without the risk of being overwritten by other software and
without being contained in a filesystem which might move its blocks
around.

   When creating a BIOS Boot Partition on a GPT system, you should make
sure that it is at least 31 KiB in size.  (GPT-formatted disks are not
usually particularly small, so we recommend that you make it larger than
the bare minimum, such as 1 MiB, to allow plenty of room for growth.)
You must also make sure that it has the proper partition type.  Using
GNU Parted, you can set this using a command such as the following:

     # parted /dev/DISK set PARTITION-NUMBER bios_grub on

   If you are using gdisk, set the partition type to ‘0xEF02’.  With
partitioning programs that require setting the GUID directly, it should
be ‘21686148-6449-6e6f-744e656564454649’.

   *Caution:* Be very careful which partition you select!  When GRUB
finds a BIOS Boot Partition during installation, it will automatically
overwrite part of it.  Make sure that the partition does not contain any
other data.

5 Booting
*********

GRUB can load Multiboot-compliant kernels in a consistent way, but for
some free operating systems you need to use some OS-specific magic.

5.1 How to boot operating systems
=================================

GRUB has three distinct boot methods: loading an operating system
directly, using kexec from userspace, and chainloading another
bootloader.  Generally speaking, the first two are more desirable
because you don't need to install or maintain other boot loaders and
GRUB is flexible enough to load an operating system from an arbitrary
disk/partition.  However, chainloading is sometimes required, as GRUB
doesn't support all existing operating systems natively.

5.1.1 How to boot an OS directly with GRUB
------------------------------------------

Multiboot (see Multiboot Specification (multiboot)) is the native
format supported by GRUB. For the sake of convenience, there is also
support for Linux, FreeBSD, NetBSD and OpenBSD. If you want to boot
other operating systems, you will have to chain-load them (see
Chain-loading).

   FIXME: this section is incomplete.

  1. Run the command ‘boot’ (see boot).

   However, DOS and Windows have some deficiencies, so you might have to
use more complicated instructions.  See DOS/Windows, for more
information.

5.1.2 Kexec with grub2-emu
--------------------------

GRUB can be run in userspace by invoking the grub2-emu tool.  It will
read all configuration scripts as if booting directly (see Loading an operating system directly).
With the ‘--kexec’ flag, and kexec(8)
support from the operating system, the ‘linux’ command will directly
boot the target image.  For systems that lack working systemctl(1)
support for kexec, passing the ‘--kexec’ flag twice will fallback to
invoking kexec(8) directly; note however that this fallback may be
unsafe outside read-only environments, as it does not invoke shutdown
machinery.

5.1.3 Chain-loading an OS
-------------------------

Operating systems that do not support Multiboot and do not have specific
support in GRUB (specific support is available for Linux, FreeBSD,
NetBSD and OpenBSD) must be chain-loaded, which involves loading another
boot loader and jumping to it in real mode or via the firmware.

   The ‘chainloader’ command (see chainloader) is used to set this
up.  It is normally also necessary to load some GRUB modules and set the
appropriate root device.  Putting this together, we get something like
this, for a Windows system on the first partition of the first hard
disk:

menuentry "Windows" {
	insmod chain
	insmod ntfs
	set root=(hd0,1)
	chainloader +1
}

   On systems with multiple hard disks, an additional workaround may be
required.  See DOS/Windows.

   Chain-loading is only supported on PC BIOS and EFI platforms.

5.2 Loopback booting
====================

GRUB is able to read from an image (be it one of CD or HDD) stored on
any of its accessible storages (refer to loopback command).
However the OS itself should be able to find its root.  This usually
involves running a userspace program running before the real root is
discovered.  This is achieved by GRUB loading a specially made small
image and passing it as ramdisk to the kernel.  This is achieved by
commands ‘kfreebsd_module’, ‘knetbsd_module_elf’, ‘kopenbsd_ramdisk’,
‘initrd’ (see initrd), ‘initrd16’ (see initrd16),
‘multiboot_module’, ‘multiboot2_module’ or ‘xnu_ramdisk’ depending on
the loader.  Note that for knetbsd the image must be put inside
miniroot.kmod and the whole miniroot.kmod has to be loaded.  In kopenbsd
payload this is disabled by default.  Additionally, behaviour of initial
ramdisk depends on command line options.  Several distributors provide
the image for this purpose or it's integrated in their standard ramdisk
and activated by special option.  Consult your kernel and distribution
manual for more details.  Other loaders like ‘appleloader’,
‘chainloader’ (BIOS, EFI, coreboot), ‘freedos’, ‘ntldr’, ‘plan9’ and
‘truecrypt’ provide no possibility of loading initial ramdisk and as far
as author is aware the payloads in question don't support either initial
ramdisk or discovering loopback boot in other way and as such not
bootable this way.  Please consider alternative boot methods like
copying all files from the image to actual partition.  Consult your OS
documentation for more details.

5.3 Booting from LVM cache logical volume
=========================================

The LVM cache logical volume is the logical volume consisting of the
original and the cache pool logical volume.  The original is usually on
a larger and slower storage device while the cache pool is on a smaller
and faster one.  The performance of the original volume can be improved
by storing the frequently used data on the cache pool to utilize the
greater performance of faster device.

   GRUB boots from LVM cache logical volume merely by reading it's
original logical volume so that dirty data in cache pool volume is
disregarded.  This is not a problem for "writethrough" cache mode as it
ensures that any data written will be stored both on the cache and the
origin LV. For the other cache mode "writeback", which delays writing
from the cache pool back to the origin LV to boost performance, GRUB may
fail to boot in the wake of accidental power outage due to it's
inability to assemble the cache device for reading the required dirty
data left behind.  The situation will be improved after adding full
support to the LVM cache logical volume in the future.

5.4 Some caveats on OS-specific issues
======================================

Here, we describe some caveats on several operating systems.

5.4.1 GNU/Hurd
--------------

Since GNU/Hurd is Multiboot-compliant, it is easy to boot it; there is
nothing special about it.  But do not forget that you have to specify a
root partition to the kernel.

  1. Set GRUB's root device to the same drive as GNU/Hurd's.  The
     command ‘search --set=root --file /boot/gnumach.gz’ or similar may
     help you (see search).

  2. Load the kernel and the modules, like this:

          grub> multiboot /boot/gnumach.gz root=device:hd0s1
          grub> module  /hurd/ext2fs.static ext2fs --readonly \
                             --multiboot-command-line='${kernel-command-line}' \
                             --host-priv-port='${host-port}' \
                             --device-master-port='${device-port}' \
                             --exec-server-task='${exec-task}' -T typed '${root}' \
                             '$(task-create)' '$(task-resume)'
          grub> module /lib/ld.so.1 exec /hurd/exec '$(exec-task=task-create)'

  3. Finally, run the command ‘boot’ (see boot).

5.4.2 GNU/Linux
---------------

It is relatively easy to boot GNU/Linux from GRUB, because it somewhat
resembles to boot a Multiboot-compliant OS.

  1. Set GRUB's root device to the same drive as GNU/Linux's.  The
     command ‘search --set=root --file /vmlinuz’ or similar may help you
     (see search).

  2. Load the kernel using the command ‘linux’ (see linux):

          grub> linux /vmlinuz root=/dev/sda1

     If you need to specify some kernel parameters, just append them to
     the command.  For example, to set ‘acpi’ to ‘off’, do this:

          grub> linux /vmlinuz root=/dev/sda1 acpi=off

     See the documentation in the Linux source tree for complete
     information on the available options.

     With ‘linux’ GRUB uses 32-bit protocol.  Some BIOS services like
     APM or EDD aren't available with this protocol.  In this case you
     need to use ‘linux16’

          grub> linux16 /vmlinuz root=/dev/sda1 acpi=off

  3. If you use an initrd, execute the command ‘initrd’ (see initrd)
     after ‘linux’:

          grub> initrd /initrd

     If you used ‘linux16’ you need to use ‘initrd16’:

          grub> initrd16 /initrd

  4. Finally, run the command ‘boot’ (see boot).

5.4.3 NetBSD
------------

Booting a NetBSD kernel from GRUB is also relatively easy: first set
GRUB's root device, then load the kernel and the modules, and finally
run ‘boot’.

  1. Set GRUB's root device to the partition holding the NetBSD root
     file system.  For a disk with a NetBSD disk label, this is usually
     the first partition (a:).  In that case, and assuming that the
     partition is on the first hard disk, set GRUB's root device as
     follows:

          grub> insmod part_bsd
          grub> set root=(hd0,netbsd1)

     For a disk with a GUID Partition Table (GPT), and assuming that the
     NetBSD root partition is the third GPT partition, do this:

          grub> insmod part_gpt
          grub> set root=(hd0,gpt3)

  2. Load the kernel using the command ‘knetbsd’:

          grub> knetbsd /netbsd

     Various options may be given to ‘knetbsd’.  These options are, for
     the most part, the same as in the NetBSD boot loader.  For
     instance, to boot the system in single-user mode and with verbose
     messages, do this:

          grub> knetbsd /netbsd -s -v

  3. If needed, load kernel modules with the command
     ‘knetbsd_module_elf’.  A typical example is the module for the root
     file system:

          grub> knetbsd_module_elf /stand/amd64/6.0/modules/ffs/ffs.kmod

  4. Finally, run the command ‘boot’ (see boot).

5.4.4 DOS/Windows
-----------------

GRUB cannot boot DOS or Windows directly, so you must chain-load them
(see Chain-loading).  However, their boot loaders have some critical
deficiencies, so it may not work to just chain-load them.  To overcome
the problems, GRUB provides you with two helper functions.

   If you have installed DOS (or Windows) on a non-first hard disk, you
have to use the disk swapping technique, because that OS cannot boot
from any disks but the first one.  The workaround used in GRUB is the
command ‘drivemap’ (see drivemap), like this:

     drivemap -s (hd0) (hd1)

   This performs a “virtual” swap between your first and second hard
drive.

   *Caution:* This is effective only if DOS (or Windows) uses BIOS to
access the swapped disks.  If that OS uses a special driver for the
disks, this probably won't work.

   Another problem arises if you installed more than one set of
DOS/Windows onto one disk, because they could be confused if there are
more than one primary partitions for DOS/Windows.  Certainly you should
avoid doing this, but there is a solution if you do want to do so.  Use
the partition hiding/unhiding technique.

   If GRUB “hides” a DOS (or Windows) partition (see parttool), DOS
(or Windows) will ignore the partition.  If GRUB “unhides” a DOS (or
Windows) partition, DOS (or Windows) will detect the partition.  Thus,
if you have installed DOS (or Windows) on the first and the second
partition of the first hard disk, and you want to boot the copy on the
first partition, do the following:

     parttool (hd0,1) hidden-
     parttool (hd0,2) hidden+
     set root=(hd0,1)
     chainloader +1
     parttool ${root} boot+
     boot

6 Writing your own configuration file
*************************************

GRUB is configured using ‘grub.cfg’, usually located under ‘/boot/grub’.
This file is quite flexible, but most users will not need to write the
whole thing by hand.

6.1 Simple configuration handling
=================================

The program ‘grub-mkconfig’ (see Invoking grub-mkconfig) generates
‘grub.cfg’ files suitable for most cases.  It is suitable for use when
upgrading a distribution, and will discover available kernels and
attempt to generate menu entries for them.

   ‘grub-mkconfig’ does have some limitations.  While adding extra
custom menu entries to the end of the list can be done by editing
‘/etc/grub.d/40_custom’ or creating ‘/boot/grub/custom.cfg’, changing
the order of menu entries or changing their titles may require making
complex changes to shell scripts stored in ‘/etc/grub.d/’.  This may be
improved in the future.  In the meantime, those who feel that it would
be easier to write ‘grub.cfg’ directly are encouraged to do so (see
Booting, and Shell-like scripting), and to disable any system
provided by their distribution to automatically run ‘grub-mkconfig’.

   The file ‘/etc/default/grub’ controls the operation of
‘grub-mkconfig’.  It is sourced by a shell script, and so must be valid
POSIX shell input; normally, it will just be a sequence of ‘KEY=value’
lines, but if the value contains spaces or other special characters then
it must be quoted.  For example:

     GRUB_TERMINAL_INPUT="console serial"

   Valid keys in ‘/etc/default/grub’ are as follows:

‘GRUB_DEFAULT’
     The default menu entry.  This may be a number, in which case it
     identifies the Nth entry in the generated menu counted from zero,
     or the title of a menu entry, or the special string ‘saved’.  Using
     the id may be useful if you want to set a menu entry as the default
     even though there may be a variable number of entries before it.

     For example, if you have:

     menuentry 'Example GNU/Linux distribution' --class gnu-linux --id example-gnu-linux {
     	...
     }

     then you can make this the default using:

          GRUB_DEFAULT=example-gnu-linux

     Previously it was documented the way to use entry title.  While
     this still works it's not recommended since titles often contain
     unstable device names and may be translated

     If you set this to ‘saved’, then the default menu entry will be
     that saved by ‘GRUB_SAVEDEFAULT’ or ‘grub-set-default’.  This
     relies on the environment block, which may not be available in all
     situations (see Environment block).

     The default is ‘0’.

‘GRUB_SAVEDEFAULT’
     If this option is set to ‘true’, then, when an entry is selected,
     save it as a new default entry for use by future runs of GRUB. This
     is only useful if ‘GRUB_DEFAULT=saved’; it is a separate option
     because ‘GRUB_DEFAULT=saved’ is useful without this option, in
     conjunction with ‘grub-set-default’.  Unset by default.  This
     option relies on the environment block, which may not be available
     in all situations (see Environment block).

‘GRUB_TIMEOUT’
     Boot the default entry this many seconds after the menu is
     displayed, unless a key is pressed.  The default is ‘5’.  Set to
     ‘0’ to boot immediately without displaying the menu, or to ‘-1’ to
     wait indefinitely.

     If ‘GRUB_TIMEOUT_STYLE’ is set to ‘countdown’ or ‘hidden’, the
     timeout is instead counted before the menu is displayed.

‘GRUB_TIMEOUT_STYLE’
     If this option is unset or set to ‘menu’, then GRUB will display
     the menu and then wait for the timeout set by ‘GRUB_TIMEOUT’ to
     expire before booting the default entry.  Pressing a key interrupts
     the timeout.

     If this option is set to ‘countdown’ or ‘hidden’, then, before
     displaying the menu, GRUB will wait for the timeout set by
     ‘GRUB_TIMEOUT’ to expire.  If <ESC> or <F4> are pressed, or <SHIFT>
     is held down during that time, it will display the menu and wait
     for input.  If a hotkey associated with a menu entry is pressed, it
     will boot the associated menu entry immediately.  If the timeout
     expires before either of these happens, it will boot the default
     entry.  In the ‘countdown’ case, it will show a one-line indication
     of the remaining time.

‘GRUB_DEFAULT_BUTTON’
‘GRUB_TIMEOUT_BUTTON’
‘GRUB_TIMEOUT_STYLE_BUTTON’
‘GRUB_BUTTON_CMOS_ADDRESS’
     Variants of the corresponding variables without the ‘_BUTTON’
     suffix, used to support vendor-specific power buttons.  See
     Vendor power-on keys.

‘GRUB_DISTRIBUTOR’
     Set by distributors of GRUB to their identifying name.  This is
     used to generate more informative menu entry titles.

‘GRUB_TERMINAL_INPUT’
     Select the terminal input device.  You may select multiple devices
     here, separated by spaces.

     Valid terminal input names depend on the platform, but may include
     ‘console’ (native platform console), ‘serial’ (serial terminal),
     ‘serial_<port>’ (serial terminal with explicit port selection),
     ‘at_keyboard’ (PC AT keyboard), or ‘usb_keyboard’ (USB keyboard
     using the HID Boot Protocol, for cases where the firmware does not
     handle this).

     The default is to use the platform's native terminal input.

‘GRUB_TERMINAL_OUTPUT’
     Select the terminal output device.  You may select multiple devices
     here, separated by spaces.

     Valid terminal output names depend on the platform, but may include
     ‘console’ (native platform console), ‘serial’ (serial terminal),
     ‘serial_<port>’ (serial terminal with explicit port selection),
     ‘gfxterm’ (graphics-mode output), ‘vga_text’ (VGA text output),
     ‘mda_text’ (MDA text output), ‘morse’ (Morse-coding using system
     beeper) or ‘spkmodem’ (simple data protocol using system speaker).

     ‘spkmodem’ is useful when no serial port is available.  Connect the
     output of sending system (where GRUB is running) to line-in of
     receiving system (usually developer machine).  On receiving system
     compile ‘spkmodem-recv’ from ‘util/spkmodem-recv.c’ and run:

          parecord --channels=1 --rate=48000 --format=s16le | ./spkmodem-recv

     The default is to use the platform's native terminal output.

‘GRUB_TERMINAL’
     If this option is set, it overrides both ‘GRUB_TERMINAL_INPUT’ and
     ‘GRUB_TERMINAL_OUTPUT’ to the same value.

‘GRUB_SERIAL_COMMAND’
     A command to configure the serial port when using the serial
     console.  See serial.  Defaults to ‘serial’.

‘GRUB_CMDLINE_LINUX’
     Command-line arguments to add to menu entries for the Linux kernel.

‘GRUB_CMDLINE_LINUX_DEFAULT’
     Unless ‘GRUB_DISABLE_RECOVERY’ is set to ‘true’, two menu entries
     will be generated for each Linux kernel: one default entry and one
     entry for recovery mode.  This option lists command-line arguments
     to add only to the default menu entry, after those listed in
     ‘GRUB_CMDLINE_LINUX’.

‘GRUB_CMDLINE_LINUX_RECOVERY’
     Unless ‘GRUB_DISABLE_RECOVERY’ is set to ‘true’, two menu entries
     will be generated for each Linux kernel: one default entry and one
     entry for recovery mode.  This option lists command-line arguments
     to add only to the recovery menu entry, before those listed in
     ‘GRUB_CMDLINE_LINUX’.  The default is ‘single’.

‘GRUB_CMDLINE_NETBSD’
‘GRUB_CMDLINE_NETBSD_DEFAULT’
     As ‘GRUB_CMDLINE_LINUX’ and ‘GRUB_CMDLINE_LINUX_DEFAULT’, but for
     NetBSD.

‘GRUB_CMDLINE_GNUMACH’
     As ‘GRUB_CMDLINE_LINUX’, but for GNU Mach.

‘GRUB_CMDLINE_XEN’
‘GRUB_CMDLINE_XEN_DEFAULT’
     The values of these options are passed to Xen hypervisor Xen menu
     entries, for all respectively normal entries.

‘GRUB_CMDLINE_LINUX_XEN_REPLACE’
‘GRUB_CMDLINE_LINUX_XEN_REPLACE_DEFAULT’
     The values of these options replace the values of
     ‘GRUB_CMDLINE_LINUX’ and ‘GRUB_CMDLINE_LINUX_DEFAULT’ for Linux and
     Xen menu entries.

‘GRUB_TOP_LEVEL’
‘GRUB_TOP_LEVEL_XEN’
     This option should be an absolute path to a kernel image.  If
     provided, the image specified will be made the top-level entry if
     it is found in the scan.

‘GRUB_TOP_LEVEL_OS_PROBER’
     This option should be a line of output from ‘os-prober’.  As
     ‘GRUB_TOP_LEVEL’, if provided, the image specified will be made the
     top-level entry if it is found in the scan.

‘GRUB_EARLY_INITRD_LINUX_CUSTOM’
‘GRUB_EARLY_INITRD_LINUX_STOCK’
     List of space-separated early initrd images to be loaded from
     ‘/boot’.  This is for loading things like CPU microcode, firmware,
     ACPI tables, crypto keys, and so on.  These early images will be
     loaded in the order declared, and all will be loaded before the
     actual functional initrd image.

     ‘GRUB_EARLY_INITRD_LINUX_STOCK’ is for your distribution to declare
     images that are provided by the distribution.  It should not be
     modified without understanding the consequences.  They will be
     loaded first.

     ‘GRUB_EARLY_INITRD_LINUX_CUSTOM’ is for your custom created images.

     The default stock images are as follows, though they may be
     overridden by your distribution:
          intel-uc.img intel-ucode.img amd-uc.img amd-ucode.img early_ucode.cpio microcode.cpio

‘GRUB_DISABLE_LINUX_UUID’
     Normally, ‘grub-mkconfig’ will generate menu entries that use
     universally-unique identifiers (UUIDs) to identify the root
     filesystem to the Linux kernel, using a ‘root=UUID=...’ kernel
     parameter.  This is usually more reliable, but in some cases it may
     not be appropriate.  To disable the use of UUIDs, set this option
     to ‘true’.

‘GRUB_DISABLE_LINUX_PARTUUID’
     If ‘grub-mkconfig’ cannot identify the root filesystem via its
     universally-unique indentifier (UUID), ‘grub-mkconfig’ can use the
     UUID of the partition containing the filesystem to identify the
     root filesystem to the Linux kernel via a ‘root=PARTUUID=...’
     kernel parameter.  This is not as reliable as using the filesystem
     UUID, but is more reliable than using the Linux device names.  When
     ‘GRUB_DISABLE_LINUX_PARTUUID’ is set to ‘false’, the Linux kernel
     version must be 2.6.37 (3.10 for systems using the MSDOS partition
     scheme) or newer.  This option defaults to ‘true’.  To enable the
     use of partition UUIDs, set this option to ‘false’.

‘GRUB_DISABLE_RECOVERY’
     If this option is set to ‘true’, disable the generation of recovery
     mode menu entries.

‘GRUB_DISABLE_UUID’
     Normally, ‘grub-mkconfig’ will generate menu entries that use
     universally-unique identifiers (UUIDs) to identify various
     filesystems to search for files.  This is usually more reliable,
     but in some cases it may not be appropriate.  To disable this use
     of UUIDs, set this option to ‘true’.  Setting this option to
     ‘true’, will also set the options ‘GRUB_DISABLE_LINUX_UUID’ and
     ‘GRUB_DISABLE_LINUX_PARTUUID’ to ‘true’, unless they have been
     explicitly set to ‘false’.

‘GRUB_VIDEO_BACKEND’
     If graphical video support is required, either because the
     ‘gfxterm’ graphical terminal is in use or because
     ‘GRUB_GFXPAYLOAD_LINUX’ is set, then ‘grub-mkconfig’ will normally
     load all available GRUB video drivers and use the one most
     appropriate for your hardware.  If you need to override this for
     some reason, then you can set this option.

     After ‘grub-install’ has been run, the available video drivers are
     listed in ‘/boot/grub/video.lst’.

‘GRUB_GFXMODE’
     Set the resolution used on the ‘gfxterm’ graphical terminal.  Note
     that you can only use modes which your graphics card supports via
     VESA BIOS Extensions (VBE), so for example native LCD panel
     resolutions may not be available.  The default is ‘auto’, which
     tries to select a preferred resolution.  See gfxmode.

‘GRUB_BACKGROUND’
     Set a background image for use with the ‘gfxterm’ graphical
     terminal.  The value of this option must be a file readable by GRUB
     at boot time, and it must end with ‘.png’, ‘.tga’, ‘.jpg’, or
     ‘.jpeg’.  The image will be scaled if necessary to fit the screen.
     Image height and width will be restricted by an artificial limit of
     16384.

‘GRUB_THEME’
     Set a theme for use with the ‘gfxterm’ graphical terminal.

‘GRUB_GFXPAYLOAD_LINUX’
     Set to ‘text’ to force the Linux kernel to boot in normal text
     mode, ‘keep’ to preserve the graphics mode set using
     ‘GRUB_GFXMODE’, ‘WIDTHxHEIGHT’[‘xDEPTH’] to set a particular
     graphics mode, or a sequence of these separated by commas or
     semicolons to try several modes in sequence.  See gfxpayload.

     Depending on your kernel, your distribution, your graphics card,
     and the phase of the moon, note that using this option may cause
     GNU/Linux to suffer from various display problems, particularly
     during the early part of the boot sequence.  If you have problems,
     set this option to ‘text’ and GRUB will tell Linux to boot in
     normal text mode.

‘GRUB_DISABLE_OS_PROBER’
     The ‘grub-mkconfig’ has a feature to use the external ‘os-prober’
     program to discover other operating systems installed on the same
     machine and generate appropriate menu entries for them.  It is
     disabled by default since automatic and silent execution of
     ‘os-prober’, and creating boot entries based on that data, is a
     potential attack vector.  Set this option to ‘false’ to enable this
     feature in the ‘grub-mkconfig’ command.

‘GRUB_OS_PROBER_SKIP_LIST’
     List of space-separated case insensitive UUIDs of filesystems to be
     ignored from os-prober output.  For EFI chainloaders it's
     <UUID>@<EFI FILE>.  For backward compatibility with previous
     behaviour, <UUID>@/dev/* is also accepted for non-EFI chainloaders
     even if the device does not match, and comma and semicolon are also
     accepted as separator.

‘GRUB_DISABLE_SUBMENU’
     Normally, ‘grub-mkconfig’ will generate top level menu entry for
     the kernel with highest version number and put all other found
     kernels or alternative menu entries for recovery mode in submenu.
     For entries returned by ‘os-prober’ first entry will be put on top
     level and all others in submenu.  If this option is set to ‘true’,
     flat menu with all entries on top level will be generated instead.
     Changing this option will require changing existing values of
     ‘GRUB_DEFAULT’, ‘fallback’ (see fallback) and ‘default’ (see
     default) environment variables as well as saved default entry
     using ‘grub-set-default’ and value used with ‘grub-reboot’.

‘GRUB_ENABLE_CRYPTODISK’
     If set to ‘y’, ‘grub-mkconfig’ and ‘grub-install’ will check for
     encrypted disks and generate additional commands needed to access
     them during boot.  Note that in this case unattended boot is not
     possible because GRUB will wait for passphrase to unlock encrypted
     container.

‘GRUB_INIT_TUNE’
     Play a tune on the speaker when GRUB starts.  This is particularly
     useful for users unable to see the screen.  The value of this
     option is passed directly to play.

‘GRUB_BADRAM’
     If this option is set, GRUB will issue a badram command to
     filter out specified regions of RAM.

‘GRUB_PRELOAD_MODULES’
     This option may be set to a list of GRUB module names separated by
     spaces.  Each module will be loaded as early as possible, at the
     start of ‘grub.cfg’.

   The following options are still accepted for compatibility with
existing configurations, but have better replacements:

‘GRUB_HIDDEN_TIMEOUT’
     Wait this many seconds before displaying the menu.  If <ESC> or
     <F4> are pressed, or <SHIFT> is held down during that time, display
     the menu and wait for input according to ‘GRUB_TIMEOUT’.  If a
     hotkey associated with a menu entry is pressed, boot the associated
     menu entry immediately.  If the timeout expires before either of
     these happens, display the menu for the number of seconds specified
     in ‘GRUB_TIMEOUT’ before booting the default entry.

     If you set ‘GRUB_HIDDEN_TIMEOUT’, you should also set
     ‘GRUB_TIMEOUT=0’ so that the menu is not displayed at all unless
     <ESC> or <F4> are pressed, or <SHIFT> is held down.

     This option is unset by default, and is deprecated in favour of the
     less confusing ‘GRUB_TIMEOUT_STYLE=countdown’ or
     ‘GRUB_TIMEOUT_STYLE=hidden’.

‘GRUB_HIDDEN_TIMEOUT_QUIET’
     In conjunction with ‘GRUB_HIDDEN_TIMEOUT’, set this to ‘true’ to
     suppress the verbose countdown while waiting for a key to be
     pressed before displaying the menu.

     This option is unset by default, and is deprecated in favour of the
     less confusing ‘GRUB_TIMEOUT_STYLE=countdown’.

‘GRUB_HIDDEN_TIMEOUT_BUTTON’
     Variant of ‘GRUB_HIDDEN_TIMEOUT’, used to support vendor-specific
     power buttons.  See Vendor power-on keys.

     This option is unset by default, and is deprecated in favour of the
     less confusing ‘GRUB_TIMEOUT_STYLE=countdown’ or
     ‘GRUB_TIMEOUT_STYLE=hidden’.

   For more detailed customisation of ‘grub-mkconfig’'s output, you may
edit the scripts in ‘/etc/grub.d’ directly.  ‘/etc/grub.d/40_custom’ is
particularly useful for adding entire custom menu entries; simply type
the menu entries you want to add at the end of that file, making sure to
leave at least the first two lines intact.

6.2 Root Identification Heuristics
==================================

If the target operating system uses the Linux kernel, ‘grub-mkconfig’
attempts to identify the root file system via a heuristic algoirthm.
This algorithm selects the identification method of the root file system
by considering three factors.  The first is if an initrd for the target
operating system is also present.  The second is
‘GRUB_DISABLE_LINUX_UUID’ and if set to ‘true’, prevents ‘grub-mkconfig’
from identifying the root file system by its UUID. The third is
‘GRUB_DISABLE_LINUX_PARTUUID’ and if set to ‘true’, prevents
‘grub-mkconfig’ from identifying the root file system via the UUID of
its enclosing partition.  If the variables are assigned any other value,
that value is considered equivalent to ‘false’.  The variables are also
considered to be set to ‘false’ if they are not set.

   When booting, the Linux kernel will delegate the task of mounting the
root filesystem to the initrd.  Most initrd images determine the root
file system by checking the Linux kernel's command-line for the ‘root’
key and use its value as the identification method of the root file
system.  To improve the reliability of booting, most initrd images also
allow the root file system to be identified by its UUID. Because of this
behavior, the ‘grub-mkconfig’ command will set ‘root’ to ‘root=UUID=...’
to provide the initrd with the filesystem UUID of the root file system.

   If no initrd is detected or ‘GRUB_DISABLE_LINUX_UUID’ is set to
‘true’ then ‘grub-command’ will identify the root filesystem by setting
the kernel command-line variable ‘root’ to ‘root=PARTUUID=...’ unless
‘GRUB_DISABLE_LINUX_PARTUUID’ is also set to ‘true’.  If
‘GRUB_DISABLE_LINUX_PARTUUID’ is also set to ‘true’, ‘grub-command’ will
identify by its Linux device name.

   The following table summarizes the behavior of the ‘grub-mkconfig’
command.

Initrd     GRUB_DISABLE_LINUX_PARTUUID   GRUB_DISABLE_LINUX_UUID   Linux Root
detected   Set To                        Set To                    ID Method
--------------------------------------------------------------------------------
false      false                         false                     part UUID
false      false                         true                      part UUID
false      true                          false                     dev name
false      true                          true                      dev name
true       false                         false                     fs UUID
true       false                         true                      part UUID
true       true                          false                     fs UUID
true       true                          true                      dev name

   Remember, ‘GRUB_DISABLE_LINUX_PARTUUID’ and ‘GRUB_DISABLE_LINUX_UUID’
are also considered to be set to ‘true’ and ‘false’, respectively, when
they are unset.

6.3 Writing full configuration files directly
=============================================

‘grub.cfg’ is written in GRUB's built-in scripting language, which has a
syntax quite similar to that of GNU Bash and other Bourne shell
derivatives.

Words
=====

A “word” is a sequence of characters considered as a single unit by
GRUB. Words are separated by “metacharacters”, which are the following
plus space, tab, and newline:

     { } | & $ ; < >

   Quoting may be used to include metacharacters in words; see below.

Reserved words
==============

Reserved words have a special meaning to GRUB. The following words are
recognised as reserved when unquoted and either the first word of a
simple command or the third word of a ‘for’ command:

     ! [[ ]] { }
     case do done elif else esac fi for function
     if in menuentry select then time until while

   Not all of these reserved words have a useful purpose yet; some are
reserved for future expansion.

Quoting
=======

Quoting is used to remove the special meaning of certain characters or
words.  It can be used to treat metacharacters as part of a word, to
prevent reserved words from being recognised as such, and to prevent
variable expansion.

   There are three quoting mechanisms: the escape character, single
quotes, and double quotes.

   A non-quoted backslash (\) is the “escape character”.  It preserves
the literal value of the next character that follows, with the exception
of newline.

   Enclosing characters in single quotes preserves the literal value of
each character within the quotes.  A single quote may not occur between
single quotes, even when preceded by a backslash.

   Enclosing characters in double quotes preserves the literal value of
all characters within the quotes, with the exception of ‘$’ and ‘\’.
The ‘$’ character retains its special meaning within double quotes.  The
backslash retains its special meaning only when followed by one of the
following characters: ‘$’, ‘"’, ‘\’, or newline.  A backslash-newline
pair is treated as a line continuation (that is, it is removed from the
input stream and effectively ignored(1) (1)).
A double quote may be quoted within double
quotes by preceding it with a backslash.

Variable expansion
==================

The ‘$’ character introduces variable expansion.  The variable name to
be expanded may be enclosed in braces, which are optional but serve to
protect the variable to be expanded from characters immediately
following it which could be interpreted as part of the name.

   Normal variable names begin with an alphabetic character, followed by
zero or more alphanumeric characters.  These names refer to entries in
the GRUB environment (see Environment).

   Positional variable names consist of one or more digits.  They
represent parameters passed to function calls, with ‘$1’ representing
the first parameter, and so on.

   The special variable name ‘?’ expands to the exit status of the most
recently executed command.  When positional variable names are active,
other special variable names ‘@’, ‘*’ and ‘#’ are defined and they
expand to all positional parameters with necessary quoting, positional
parameters without any quoting, and positional parameter count
respectively.

Comments
========

A word beginning with ‘#’ causes that word and all remaining characters
on that line to be ignored.

Simple commands
===============

A “simple command” is a sequence of words separated by spaces or tabs
and terminated by a semicolon or a newline.  The first word specifies
the command to be executed.  The remaining words are passed as arguments
to the invoked command.

   The return value of a simple command is its exit status.  If the
reserved word ‘!’ precedes the command, then the return value is instead
the logical negation of the command's exit status.

Compound commands
=================

A “compound command” is one of the following:

for NAME in WORD ...; do LIST; done
     The list of words following ‘in’ is expanded, generating a list of
     items.  The variable NAME is set to each element of this list in
     turn, and LIST is executed each time.  The return value is the exit
     status of the last command that executes.  If the expansion of the
     items following ‘in’ results in an empty list, no commands are
     executed, and the return status is 0.

if LIST; then LIST; [elif LIST; then LIST;] ... [else LIST;] fi
     The ‘if’ LIST is executed, where LIST is a series of “simple
     command”s separated by a ";".  If its exit status of the last
     command is zero, the ‘then’ LIST is executed.  Otherwise, each
     ‘elif’ LIST is executed in turn, and if its last command's exit
     status is zero, the corresponding ‘then’ LIST is executed and the
     command completes.  Otherwise, the ‘else’ LIST is executed, if
     present.  The exit status is the exit status of the last command
     executed, or zero if no condition tested true.

while COND; do LIST; done
until COND; do LIST; done
     The ‘while’ command continuously executes the ‘do’ LIST as long as
     the last command in COND returns an exit status of zero, where COND
     is a list of “simple command”s separated by a ";".  The ‘until’
     command is identical to the ‘while’ command, except that the test
     is negated; the ‘do’ LIST is executed as long as the last command
     in COND returns a non-zero exit status.  The exit status of the
     ‘while’ and ‘until’ commands is the exit status of the last ‘do’
     LIST command executed, or zero if none was executed.

function NAME { COMMAND; ... }
     This defines a function named NAME.  The “body” of the function is
     the list of commands within braces, each of which must be
     terminated with a semicolon or a newline.  This list of commands
     will be executed whenever NAME is specified as the name of a simple
     command.  Function definitions do not affect the exit status in
     ‘$?’.  When executed, the exit status of a function is the exit
     status of the last command executed in the body.

menuentry TITLE [‘--class=class’ ...] [‘--users=users’] [‘--unrestricted’] [‘--hotkey=key’] [‘--id=id’] { COMMAND; ... }
     See menuentry.

Built-in Commands
=================

Some built-in commands are also provided by GRUB script to help script
writers perform actions that are otherwise not possible.  For example,
these include commands to jump out of a loop without fully completing
it, etc.

break [‘n’]
     Exit from within a ‘for’, ‘while’, or ‘until’ loop.  If ‘n’ is
     specified, break ‘n’ levels.  ‘n’ must be greater than or equal to
     1.  If ‘n’ is greater than the number of enclosing loops, all
     enclosing loops are exited.  The return value is 0 unless ‘n’ is
     not greater than or equal to 1.

continue [‘n’]
     Resume the next iteration of the enclosing ‘for’, ‘while’ or
     ‘until’ loop.  If ‘n’ is specified, resume at the ‘n’th enclosing
     loop.  ‘n’ must be greater than or equal to 1.  If ‘n’ is greater
     than the number of enclosing loops, the last enclosing loop (the
     “top-level” loop) is resumed.  The return value is 0 unless ‘n’ is
     not greater than or equal to 1.

return [‘n’]
     Causes a function to exit with the return value specified by ‘n’.
     If ‘n’ is omitted, the return status is that of the last command
     executed in the function body.  If used outside a function the
     return status is false.

setparams [‘arg’] ...
     Replace positional parameters starting with ‘$1’ with arguments to
     ‘setparams’.

shift [‘n’]
     The positional parameters from ‘n’+1 ... are renamed to ‘$1’....
     Parameters represented by the numbers ‘$#’ down to ‘$#’-‘n’+1 are
     unset.  ‘n’ must be a non-negative number less than or equal to
     ‘$#’.  If ‘n’ is 0, no parameters are changed.  If ‘n’ is not
     given, it is assumed to be 1.  If ‘n’ is greater than ‘$#’, the
     positional parameters are not changed.  The return status is
     greater than zero if ‘n’ is greater than ‘$#’ or less than zero;
     otherwise 0.

   (1) Currently a backslash-newline pair within a variable name is not
handled properly, so use this feature with some care.

6.4 Multi-boot manual config
============================

Currently autogenerating config files for multi-boot environments
depends on os-prober and has several shortcomings.  Due to that it is
disabled by default.  It is advised to use the power of GRUB syntax and
do it yourself.  A possible configuration is detailed here, feel free to
adjust to your needs.

   First create a separate GRUB partition, big enough to hold GRUB. Some
of the following entries show how to load OS installer images from this
same partition, for that you obviously need to make the partition large
enough to hold those images as well.  Mount this partition on/mnt/boot
and disable GRUB in all OSes and manually install self-compiled latest
GRUB with:

   ‘grub-install --boot-directory=/mnt/boot /dev/sda’

   In all the OSes install GRUB tools but disable installing GRUB in
bootsector, so you'll have menu.lst and grub.cfg available for use.
Also disable os-prober use by setting:

   ‘GRUB_DISABLE_OS_PROBER=true’

   in /etc/default/grub

   Then write a grub.cfg (/mnt/boot/grub/grub.cfg):

     menuentry "OS using grub2" {
        insmod xfs
        search --set=root --label OS1 --hint hd0,msdos8
        configfile /boot/grub/grub.cfg
     }

     menuentry "OS using grub2-legacy" {
        insmod ext2
        search --set=root --label OS2 --hint hd0,msdos6
        legacy_configfile /boot/grub/menu.lst
     }

     menuentry "Windows XP" {
        insmod ntfs
        search --set=root --label WINDOWS_XP --hint hd0,msdos1
        ntldr /ntldr
     }

     menuentry "Windows 7" {
        insmod ntfs
        search --set=root --label WINDOWS_7 --hint hd0,msdos2
        ntldr /bootmgr
     }

     menuentry "FreeBSD" {
               insmod zfs
               search --set=root --label freepool --hint hd0,msdos7
               kfreebsd /freebsd@/boot/kernel/kernel
               kfreebsd_module_elf /freebsd@/boot/kernel/opensolaris.ko
               kfreebsd_module_elf /freebsd@/boot/kernel/zfs.ko
               kfreebsd_module /freebsd@/boot/zfs/zpool.cache type=/boot/zfs/zpool.cache
               set kFreeBSD.vfs.root.mountfrom=zfs:freepool/freebsd
               set kFreeBSD.hw.psm.synaptics_support=1
     }

     menuentry "experimental GRUB" {
               search --set=root --label GRUB --hint hd0,msdos5
               multiboot /experimental/grub/i386-pc/core.img
     }

     menuentry "Fedora 16 installer" {
               search --set=root --label GRUB --hint hd0,msdos5
               linux /fedora/vmlinuz lang=en_US keymap=sg resolution=1280x800
               initrd /fedora/initrd.img
     }

     menuentry "Fedora rawhide installer" {
               search --set=root --label GRUB --hint hd0,msdos5
               linux /fedora/vmlinuz repo=ftp://mirror.switch.ch/mirror/fedora/linux/development/rawhide/x86_64 lang=en_US keymap=sg resolution=1280x800
               initrd /fedora/initrd.img
     }

     menuentry "Debian sid installer" {
               search --set=root --label GRUB --hint hd0,msdos5
               linux /debian/dists/sid/main/installer-amd64/current/images/hd-media/vmlinuz
               initrd /debian/dists/sid/main/installer-amd64/current/images/hd-media/initrd.gz
     }

   Notes:
   • Argument to search after -label is FS LABEL. You can also use UUIDs
     with -fs-uuid UUID instead of -label LABEL. You could also use
     direct ‘root=hd0,msdosX’ but this is not recommended due to device
     name instability.

6.5 Embedding a configuration file into GRUB
============================================

GRUB supports embedding a configuration file directly into the core
image, so that it is loaded before entering normal mode.  This is
useful, for example, when it is not straightforward to find the real
configuration file, or when you need to debug problems with loading that
file.  ‘grub-install’ uses this feature when it is not using BIOS disk
functions or when installing to a different disk from the one containing
‘/boot/grub’, in which case it needs to use the ‘search’ command (see
search) to find ‘/boot/grub’.

   To embed a configuration file, use the ‘-c’ option to ‘grub-mkimage’.
The file is copied into the core image, so it may reside anywhere on the
file system, and may be removed after running ‘grub-mkimage’.

   After the embedded configuration file (if any) is executed, GRUB will
load the ‘normal’ module (see normal), which will then read the real
configuration file from ‘$prefix/grub.cfg’.  By this point, the ‘root’
variable will also have been set to the root device name.  For example,
‘prefix’ might be set to ‘(hd0,1)/boot/grub’, and ‘root’ might be set to
‘hd0,1’.  Thus, in most cases, the embedded configuration file only
needs to set the ‘prefix’ and ‘root’ variables, and then drop through to
GRUB's normal processing.  A typical example of this might look like
this:

     search.fs_uuid 01234567-89ab-cdef-0123-456789abcdef root
     set prefix=($root)/boot/grub

   (The ‘search_fs_uuid’ module must be included in the core image for
this example to work.)

   In more complex cases, it may be useful to read other configuration
files directly from the embedded configuration file.  This allows such
things as reading files not called ‘grub.cfg’, or reading files from a
directory other than that where GRUB's loadable modules are installed.
To do this, include the ‘configfile’ and ‘normal’ modules in the core
image, and embed a configuration file that uses the ‘configfile’ command
to load another file.  The following example of this also requires the
‘echo’, ‘search_label’, and ‘test’ modules to be included in the core
image:

     search.fs_label grub root
     if [ -e /boot/grub/example/test1.cfg ]; then
         set prefix=($root)/boot/grub
         configfile /boot/grub/example/test1.cfg
     else
         if [ -e /boot/grub/example/test2.cfg ]; then
             set prefix=($root)/boot/grub
             configfile /boot/grub/example/test2.cfg
         else
             echo "Could not find an example configuration file!"
         fi
     fi

   The embedded configuration file may not contain menu entries
directly, but may only read them from elsewhere using ‘configfile’.

7 Theme file format
*******************

7.1 Introduction
================

The GRUB graphical menu supports themes that can customize the layout
and appearance of the GRUB boot menu.  The theme is configured through a
plain text file that specifies the layout of the various GUI components
(including the boot menu, timeout progress bar, and text messages) as
well as the appearance using colors, fonts, and images.  Example is
available in docs/example_theme.txt

7.2 Theme Elements
==================

7.2.1 Colors
------------

Colors can be specified in several ways:

   • HTML-style "#RRGGBB" or "#RGB" format, where *R*, *G*, and *B* are
     hexadecimal digits (e.g., "#8899FF")
   • as comma-separated decimal RGB values (e.g., "128, 128, 255")
   • with "SVG 1.0 color names" (e.g., "cornflowerblue") which must be
     specified in lowercase.

7.2.2 Fonts
-----------

The fonts GRUB uses "PFF2 font format" bitmap fonts.  Fonts are
specified with full font names.  Currently there is no provision for a
preference list of fonts, or deriving one font from another.  Fonts are
loaded with the "loadfont" command in GRUB (see loadfont).  To see
the list of loaded fonts, execute the "lsfonts" command (see
lsfonts).  If there are too many fonts to fit on screen, do "set
pager=1" before executing "lsfonts".

7.2.3 Progress Bar
------------------

Figure 7.1

Figure 7.2
Progress bars are used to display the remaining time before GRUB boots
the default menu entry.  To create a progress bar that will display the
remaining time before automatic boot, simply create a "progress_bar"
component with the id "__timeout__".  This indicates to GRUB that the
progress bar should be updated as time passes, and it should be made
invisible if the countdown to automatic boot is interrupted by the user.

   Progress bars may optionally have text displayed on them.  This text
is controlled by variable "text" which contains a printf template with
the only argument %d is the number of seconds remaining.  Additionally
special values "@TIMEOUT_NOTIFICATION_SHORT@",
"@TIMEOUT_NOTIFICATION_MIDDLE@", "@TIMEOUT_NOTIFICATION_LONG@" are
replaced with standard and translated templates.

7.2.4 Circular Progress Indicator
---------------------------------

The circular progress indicator functions similarly to the progress bar.
When given an id of "__timeout__", GRUB updates the circular progress
indicator's value to indicate the time remaining.  For the circular
progress indicator, there are two images used to render it: the *center*
image, and the *tick* image.  The center image is rendered in the center
of the component, while the tick image is used to render each mark along
the circumference of the indicator.

7.2.5 Labels
------------

Text labels can be placed on the boot screen.  The font, color, and
horizontal alignment can be specified for labels.  If a label is given
the id "__timeout__", then the "text" property for that label is also
updated with a message informing the user of the number of seconds
remaining until automatic boot.  This is useful in case you want the
text displayed somewhere else instead of directly on the progress bar.

7.2.6 Boot Menu
---------------

The boot menu where GRUB displays the menu entries from the "grub.cfg"
file.  It is a list of items, where each item has a title and an
optional icon.  The icon is selected based on the *classes* specified
for the menu entry.  If there is a PNG file named "myclass.png" in the
"grub/themes/icons" directory, it will be displayed for items which have
the class *myclass*.  The boot menu can be customized in several ways,
such as the font and color used for the menu entry title, and by
specifying styled boxes for the menu itself and for the selected item
highlight.

7.2.7 Styled Boxes
------------------

One of the most important features for customizing the layout is the use
of *styled boxes*.  A styled box is composed of 9 rectangular (and
potentially empty) regions, which are used to seamlessly draw the styled
box on screen:

Northwest (nw)         North (n)              Northeast (ne)
West (w)               Center (c)             East (e)
Southwest (sw)         South (s)              Southeast (se)

   To support any size of box on screen, the center slice and the slices
for the top, bottom, and sides are all scaled to the correct size for
the component on screen, using the following rules:

  1. The edge slices (north, south, east, and west) are scaled in the
     direction of the edge they are adjacent to.  For instance, the west
     slice is scaled vertically.
  2. The corner slices (northwest, northeast, southeast, and southwest)
     are not scaled.
  3. The center slice is scaled to fill the remaining space in the
     middle.

   As an example of how an image might be sliced up, consider the styled
box used for a terminal view.

Figure 7.3

7.2.8 Creating Styled Box Images
--------------------------------

The Inkscape_ scalable vector graphics editor is a very useful tool for
creating styled box images.  One process that works well for slicing a
drawing into the necessary image slices is:

  1. Create or open the drawing you'd like use.
  2. Create a new layer on the top of the layer stack.  Make it visible.
     Select this layer as the current layer.
  3. Draw 9 rectangles on your drawing where you'd like the slices to
     be.  Clear the fill option, and set the stroke to 1 pixel wide
     solid stroke.  The corners of the slices must meet precisely; if it
     is off by a single pixel, it will probably be evident when the
     styled box is rendered in the GRUB menu.  You should probably go to
     File | Document Properties | Grids and enable a grid or create a
     guide (click on one of the rulers next to the drawing and drag over
     the drawing; release the mouse button to place the guide) to help
     place the rectangles precisely.
  4. Right click on the center slice rectangle and choose Object
     Properties.  Change the "Id" to "slice_c" and click Set.  Repeat
     this for the remaining 8 rectangles, giving them Id values of
     "slice_n", "slice_ne", "slice_e", and so on according to the
     location.
  5. Save the drawing.
  6. Select all the slice rectangles.  With the slice layer selected,
     you can simply press Ctrl+A to select all rectangles.  The status
     bar should indicate that 9 rectangles are selected.
  7. Click the layer hide icon for the slice layer in the layer palette.
     The rectangles will remain selected, even though they are hidden.
  8. Choose File | Export Bitmap and check the *Batch export 9 selected
     objects* box.  Make sure that *Hide all except selected* is
     unchecked.  click *Export*.  This will create PNG files in the same
     directory as the drawing, named after the slices.  These can now be
     used for a styled box in a GRUB theme.

7.3 Theme File Manual
=====================

The theme file is a plain text file.  Lines that begin with "#" are
ignored and considered comments.  (Note: This may not be the case if the
previous line ended where a value was expected.)

   The theme file contains two types of statements:
  1. Global properties.
  2. Component construction.

7.3.1 Global Properties
-----------------------

7.3.2 Format
------------

Global properties are specified with the simple format:
   • name1: value1
   • name2: "value which may contain spaces"
   • name3: #88F

   In this example, name3 is assigned a color value.

7.3.3 Global Property List
--------------------------

title-text             Specifies the text to display at the top
                       center of the screen as a title.
title-font             Defines the font used for the title
                       message at the top of the screen.
title-color            Defines the color of the title message.
message-font           Currently unused.  Left for backward
                       compatibility.
message-color          Currently unused.  Left for backward
                       compatibility.
message-bg-color       Currently unused.  Left for backward
                       compatibility.
desktop-image          Specifies the image to use as the
                       background.  It will be scaled to fit the
                       screen size or proportionally scaled
                       depending on the scale method.
desktop-image-scale-methodSpecifies the scaling method for the
                       *desktop-image*.  Options are "stretch",
                       "crop", "padding", "fitwidth",
                       "fitheight".  "stretch" for fitting the
                       screen size.  Otherwise it is
                       proportional scaling of a part of
                       *desktop-image* to the part of the
                       screen.  "crop" part of the
                       *desktop-image* will be proportionally
                       scaled to fit the screen sizes.
                       "padding" the entire *desktop-image* will
                       be contained on the screen.  "fitwidth"
                       for fitting the *desktop-image*'s width
                       with screen width.  "fitheight" for
                       fitting the *desktop-image*'s height with
                       the screen height.  Default is "stretch".
desktop-image-h-align  Specifies the horizontal alignment of the
                       *desktop-image* if
                       *desktop-image-scale-method* isn't equeal
                       to "stretch".  Options are "left",
                       "center", "right".  Default is "center".
desktop-image-v-align  Specifies the vertical alignment of the
                       *desktop-image* if
                       *desktop-image-scale-method* isn't equeal
                       to "stretch".  Options are "top",
                       "center", "bottom".  Default is "center".
desktop-color          Specifies the color for the background if
                       *desktop-image* is not specified.
terminal-box           Specifies the file name pattern for the
                       styled box slices used for the command
                       line terminal window.  For example,
                       "terminal-box: terminal_*.png" will use
                       the images "terminal_c.png" as the center
                       area, "terminal_n.png" as the north (top)
                       edge, "terminal_nw.png" as the northwest
                       (upper left) corner, and so on.  If the
                       image for any slice is not found, it will
                       simply be left empty.
terminal-border        Specifies the border width of the
                       terminal window.
terminal-left          Specifies the left coordinate of the
                       terminal window.
terminal-top           Specifies the top coordinate of the
                       terminal window.
terminal-width         Specifies the width of the terminal
                       window.
terminal-height        Specifies the height of the terminal
                       window.

7.3.4 Component Construction
----------------------------

Greater customizability comes is provided by components.  A tree of
components forms the user interface.  *Containers* are components that
can contain other components, and there is always a single root
component which is an instance of a *canvas* container.

   Components are created in the theme file by prefixing the type of
component with a '+' sign:

   ‘ + label { text="GRUB" font="aqui 11" color="#8FF" } ’

   properties of a component are specified as "name = value" (whitespace
surrounding tokens is optional and is ignored) where *value* may be:
   • a single word (e.g., "align = center", "color = #FF8080"),
   • a quoted string (e.g., "text = "Hello, World!""), or
   • a tuple (e.g., "preferred_size = (120, 80)").

7.3.5 Component List
--------------------

The following is a list of the components and the properties they
support.

   • label A label displays a line of text.

     Properties:
     id             Set to "__timeout__" to display the time elapsed
                    to an automatical boot of the default entry.
     text           The text to display.  If "id" is set to
                    "__timeout__" and no "text" property is set then
                    the amount of seconds will be shown.  If set to
                    "@KEYMAP_SHORT@", "@KEYMAP_MIDDLE@" or
                    "@KEYMAP_LONG@" then predefined hotkey
                    information will be shown.
     font           The font to use for text display.
     color          The color of the text.
     align          The horizontal alignment of the text within the
                    component.  Options are "left", "center" and
                    "right".
     visible        Set to "false" to hide the label.

   • image A component that displays an image.  The image is scaled to
     fit the component.

     Properties:

     file           The full path to the image file to load.

   • progress_bar Displays a horizontally oriented progress bar.  It can
     be rendered using simple solid filled rectangles, or using a pair
     of pixmap styled boxes.

     Properties:

     id             Set to "__timeout__" to display the time elapsed
                    to an automatical boot of the default entry.
     fg_color       The foreground color for plain solid color
                    rendering.
     bg_color       The background color for plain solid color
                    rendering.
     border_color   The border color for plain solid color
                    rendering.
     text_color     The text color.
     bar_style      The styled box specification for the frame of
                    the progress bar.  Example:
                    "progress_frame_*.png" If the value is equal to
                    "highlight_style" then no styled boxes will be
                    shown.
     highlight_styleThe styled box specification for the highlighted
                    region of the progress bar.  This box will be
                    used to paint just the highlighted region of the
                    bar, and will be increased in size as the bar
                    nears completion.  Example: "progress_hl_*.png".
                    If the value is equal to "bar_style" then no
                    styled boxes will be shown.
     highlight_overlayIf this option is set to "true" then the
                    highlight box side slices (every slice except
                    the center slice) will overlay the frame box
                    side slices.  And the center slice of the
                    highlight box can move all the way (from top to
                    bottom), being drawn on the center slice of the
                    frame box.  That way we can make a progress bar
                    with round-shaped edges so there won't be a free
                    space from the highlight to the frame in top and
                    bottom scrollbar positions.  Default is "false".
     font           The font to use for progress bar.
     text           The text to display on the progress bar.  If the
                    progress bar's ID is set to "__timeout__" and
                    the value of this property is set to
                    "@TIMEOUT_NOTIFICATION_SHORT@",
                    "@TIMEOUT_NOTIFICATION_MIDDLE@" or
                    "@TIMEOUT_NOTIFICATION_LONG@", then GRUB will
                    update this property with an informative message
                    as the timeout approaches.

   • circular_progress Displays a circular progress indicator.  The
     appearance of this component is determined by two images: the
     *center* image and the *tick* image.  The center image is generally
     larger and will be drawn in the center of the component.  Around
     the circumference of a circle within the component, the tick image
     will be drawn a certain number of times, depending on the
     properties of the component.

     Properties:

     id                     Set to "__timeout__" to display the time
                            elapsed to an automatical boot of the
                            default entry.
     center_bitmap          The file name of the image to draw in the
                            center of the component.
     tick_bitmap            The file name of the image to draw for
                            the tick marks.
     num_ticks              The number of ticks that make up a full
                            circle.
     ticks_disappear        Boolean value indicating whether tick
                            marks should progressively appear, or
                            progressively disappear as *value*
                            approaches *end*.  Specify "true" or
                            "false".  Default is "false".
     start_angle            The position of the first tick mark to
                            appear or disappear.  Measured in
                            "parrots", 1 "parrot" = 1 / 256 of the
                            full circle.  Use values "xxx deg" or
                            "xxx \xc2\xb0" to set the angle in
                            degrees.

   • boot_menu Displays the GRUB boot menu.  It allows selecting items
     and executing them.

     Properties:

     item_font                     The font to use for the menu item
                                   titles.
     selected_item_font            The font to use for the selected
                                   menu item, or "inherit" (the
                                   default) to use "item_font" for
                                   the selected menu item as well.
     item_color                    The color to use for the menu item
                                   titles.
     selected_item_color           The color to use for the selected
                                   menu item, or "inherit" (the
                                   default) to use "item_color" for
                                   the selected menu item as well.
     icon_width                    The width of menu item icons.
                                   Icons are scaled to the specified
                                   size.
     icon_height                   The height of menu item icons.
     item_height                   The height of each menu item in
                                   pixels.
     item_padding                  The amount of space in pixels to
                                   leave on each side of the menu
                                   item contents.
     item_icon_space               The space between an item's icon
                                   and the title text, in pixels.
     item_spacing                  The amount of space to leave
                                   between menu items, in pixels.
     menu_pixmap_style             The image file pattern for the
                                   menu frame styled box.  Example:
                                   "menu_*.png" (this will use images
                                   such as "menu_c.png",
                                   "menu_w.png", 'menu_nw.png", etc.)
     item_pixmap_style             The image file pattern for the
                                   item styled box.
     selected_item_pixmap_style    The image file pattern for the
                                   selected item highlight styled
                                   box.
     scrollbar                     Boolean value indicating whether
                                   the scroll bar should be drawn if
                                   the frame and thumb styled boxes
                                   are configured.
     scrollbar_frame               The image file pattern for the
                                   entire scroll bar.  Example:
                                   "scrollbar_*.png"
     scrollbar_thumb               The image file pattern for the
                                   scroll bar thumb (the part of the
                                   scroll bar that moves as scrolling
                                   occurs).  Example:
                                   "scrollbar_thumb_*.png"
     scrollbar_thumb_overlay       If this option is set to "true"
                                   then the scrollbar thumb side
                                   slices (every slice except the
                                   center slice) will overlay the
                                   scrollbar frame side slices.  And
                                   the center slice of the
                                   scrollbar_thumb can move all the
                                   way (from top to bottom), being
                                   drawn on the center slice of the
                                   scrollbar frame.  That way we can
                                   make a scrollbar with round-shaped
                                   edges so there won't be a free
                                   space from the thumb to the frame
                                   in top and bottom scrollbar
                                   positions.  Default is "false".
     scrollbar_slice               The menu frame styled box's slice
                                   in which the scrollbar will be
                                   drawn.  Possible values are
                                   "west", "center", "east"
                                   (default).  "west" - the scrollbar
                                   will be drawn in the west slice
                                   (right-aligned).  "east" - the
                                   scrollbar will be drawn in the
                                   east slice (left-aligned).
                                   "center" - the scrollbar will be
                                   drawn in the center slice.  Note:
                                   in case of "center" slice: a) If
                                   the scrollbar should be drawn then
                                   boot menu entry's width is
                                   decreased by the scrollbar's width
                                   and the scrollbar is drawn at the
                                   right side of the center slice.
                                   b) If the scrollbar won't be drawn
                                   then the boot menu entry's width
                                   is the width of the center slice.
                                   c) We don't necessary need the
                                   menu pixmap box to display the
                                   scrollbar.
     scrollbar_left_pad            The left scrollbar padding in
                                   pixels.  Unused if
                                   "scrollbar_slice" is "west".
     scrollbar_right_pad           The right scrollbar padding in
                                   pixels.  Unused if
                                   "scrollbar_slice" is "east".
     scrollbar_top_pad             The top scrollbar padding in
                                   pixels.
     scrollbar_bottom_pad          The bottom scrollbar padding in
                                   pixels.
     visible                       Set to "false" to hide the boot
                                   menu.

   • canvas Canvas is a container that allows manual placement of
     components within it.  It does not alter the positions of its child
     components.  It assigns all child components their preferred sizes.

   • hbox The *hbox* container lays out its children from left to right,
     giving each one its preferred width.  The height of each child is
     set to the maximum of the preferred heights of all children.

   • vbox The *vbox* container lays out its children from top to bottom,
     giving each one its preferred height.  The width of each child is
     set to the maximum of the preferred widths of all children.

7.3.6 Common properties
-----------------------

The following properties are supported by all components:
‘left’
     The distance from the left border of container to left border of
     the object in either of three formats:
     x              Value in pixels
     p%             Percentage
     p%+x           mixture of both
‘top’
     The distance from the left border of container to left border of
     the object in same format.
‘width’
     The width of object in same format.
‘height’
     The height of object in same format.
‘id’
     The identifier for the component.  This can be any arbitrary
     string.  The ID can be used by scripts to refer to various
     components in the GUI component tree.  Currently, there is one
     special ID value that GRUB recognizes:

     "__timeout__"  Component with this ID will be updated by GRUB
                    and will indicate time elapsed to an automatical
                    boot of the default entry.  Affected components:
                    "label", "circular_progress", "progress_bar".

8 Booting GRUB from the network
*******************************

The following instructions don't work for *-emu, i386-qemu,
i386-coreboot, i386-multiboot, mips_loongson, mips-arc and
mips_qemu_mips

   To generate a netbootable directory, run:

     grub-mknetdir --net-directory=/srv/tftp --subdir=/boot/grub -d /usr/lib/grub/<platform>

   E.g.  for i386-pc:

     grub-mknetdir --net-directory=/srv/tftp --subdir=/boot/grub -d /usr/lib/grub/i386-pc

   Then follow instructions printed out by grub-mknetdir on configuring
your DHCP server.

   The grub.cfg file is placed in the same directory as the path output
by grub-mknetdir hereafter referred to as FWPATH. GRUB will search for
its configuration files in order using the following rules where the
appended value corresponds to a value on the client machine.

     ‘(FWPATH)’/grub.cfg-‘(UUID OF MACHINE)’
     ‘(FWPATH)’/grub.cfg-01-‘(MAC ADDRESS OF NIC)’
     ‘(FWPATH)’/grub.cfg-‘(IPv4 OR IPv6 ADDRESS)’
     ‘(FWPATH)’/grub.cfg

   The UUID is the Client Machine Identifier Option Definition as
specified in RFC 4578.  The client will only attempt to look up a UUID
config file if it was provided by the DHCP server.

   The client will only attempt to look up an IPv6 address config once,
however, it will try the IPv4 multiple times.  The concrete example
below shows what would happen under the IPv4 case.

     UUID: 7726a678-7fc0-4853-a4f6-c85ac36a120a
     MAC:  52:54:00:ec:33:81
     IPV4: 10.0.0.130 (0A000082)

     ‘(FWPATH)’/grub.cfg-7726a678-7fc0-4853-a4f6-c85ac36a120a
     ‘(FWPATH)’/grub.cfg-01-52-54-00-ec-33-81
     ‘(FWPATH)’/grub.cfg-0A000082
     ‘(FWPATH)’/grub.cfg-0A00008
     ‘(FWPATH)’/grub.cfg-0A0000
     ‘(FWPATH)’/grub.cfg-0A000
     ‘(FWPATH)’/grub.cfg-0A00
     ‘(FWPATH)’/grub.cfg-0A0
     ‘(FWPATH)’/grub.cfg-0A
     ‘(FWPATH)’/grub.cfg-0
     ‘(FWPATH)’/grub.cfg

   This feature is enabled by default but it can be disabled by setting
the ‘feature_net_search_cfg’ to ‘n’.  Since this happens before the
configuration file is read by GRUB, this option has to be disabled in an
embedded configuration file (see Embedded configuration).

   After GRUB has started, files on the TFTP server will be accessible
via the ‘(tftp)’ device.

   The server IP address can be controlled by changing the ‘(tftp)’
device name to ‘(tftp,SERVER-IP)’.  Note that this should be changed
both in the prefix and in any references to the device name in the
configuration file.

   GRUB provides several environment variables which may be used to
inspect or change the behaviour of the PXE device.  In the following
description <INTERFACE> is placeholder for the name of network interface
(platform dependent):

‘net_<INTERFACE>_ip’
     The network interface's IP address.  Read-only.

‘net_<INTERFACE>_mac’
     The network interface's MAC address.  Read-only.

‘net_<INTERFACE>_clientid’
     The client id provided by DHCP. Read-only.

‘net_<INTERFACE>_clientuuid’
     The client uuid provided by DHCP. Read-only.

‘net_<INTERFACE>_hostname’
     The client host name provided by DHCP. Read-only.

‘net_<INTERFACE>_domain’
     The client domain name provided by DHCP. Read-only.

‘net_<INTERFACE>_rootpath’
     The path to the client's root disk provided by DHCP. Read-only.

‘net_<INTERFACE>_extensionspath’
     The path to additional DHCP vendor extensions provided by DHCP.
     Read-only.

‘net_<INTERFACE>_boot_file’
     The boot file name provided by DHCP. Read-only.

‘net_<INTERFACE>_dhcp_server_name’
     The name of the DHCP server responsible for these boot parameters.
     Read-only.

‘net_<INTERFACE>_next_server’
     The IP address of the next (usually, TFTP) server provided by DHCP.
     Read-only.

‘net_default_interface’
     Initially set to name of network interface that was used to load
     grub.  Read-write, although setting it affects only interpretation
     of ‘net_default_ip’ and ‘net_default_mac’

‘net_default_ip’
     The IP address of default interface.  Read-only.  This is alias for
     the ‘net_${net_default_interface}_ip’.

‘net_default_mac’
     The default interface's MAC address.  Read-only.  This is alias for
     the ‘net_${net_default_interface}_mac’.

‘net_default_server’
     The default server used by network drives (see Device syntax).
     Read-write, although setting this is only useful before opening a
     network device.

‘pxe_default_server’
     This performs the same function as ‘net_default_server’.

9 Using GRUB via a serial line
******************************

This chapter describes how to use the serial terminal support in GRUB.

   If you have many computers or computers with no display/keyboard, it
could be very useful to control the computers through serial
communications.  To connect one computer with another via a serial line,
you need to prepare a null-modem (cross) serial cable, and you may need
to have multiport serial boards, if your computer doesn't have extra
serial ports.  In addition, a terminal emulator is also required, such
as minicom.  Refer to a manual of your operating system, for more
information.

   As for GRUB, the instruction to set up a serial terminal is quite
simple.  Here is an example:

     grub> serial --unit=0 --speed=9600
     grub> terminal_input serial; terminal_output serial

   The command ‘serial’ initializes the serial unit 0 with the speed
9600bps.  The serial unit 0 is usually called ‘COM1’, so, if you want to
use COM2, you must specify ‘--unit=1’ instead.  This command accepts
many other options, see serial for more details.

   Without argument or with ‘--port=auto’, GRUB will attempt to use ACPI
when available to auto-detect the default serial port and its
configuration.

   The commands ‘terminal_input’ (see terminal_input) and
‘terminal_output’ (see terminal_output) choose which type of
terminal you want to use.  In the case above, the terminal will be a
serial terminal, but you can also pass ‘console’ to the command, as
‘terminal_input serial console’.  In this case, a terminal in which you
press any key will be selected as a GRUB terminal.  In the example
above, note that you need to put both commands on the same command line,
as you will lose the ability to type commands on the console after the
first command.

   However, note that GRUB assumes that your terminal emulator is
compatible with VT100 by default.  This is true for most terminal
emulators nowadays.  However if your terminal emulator is not
VT100-compatible or implements few VT100 escape sequences, you shoud
tell GRUB that the terminal is dumb using the ‘terminfo’ (see
terminfo) command.  This will have GRUB provide you with an
alternative menu interface, because the normal menu requires several
fancy features of your terminal.

10 Using GRUB with vendor power-on keys
***************************************

Some laptop vendors provide an additional power-on button which boots
another OS. GRUB supports such buttons with the ‘GRUB_TIMEOUT_BUTTON’,
‘GRUB_TIMEOUT_STYLE_BUTTON’, ‘GRUB_DEFAULT_BUTTON’, and
‘GRUB_BUTTON_CMOS_ADDRESS’ variables in default/grub (see Simple configuration).
‘GRUB_TIMEOUT_BUTTON’, ‘GRUB_TIMEOUT_STYLE_BUTTON’,
and ‘GRUB_DEFAULT_BUTTON’ are used instead of the corresponding
variables without the ‘_BUTTON’ suffix when powered on using the special
button.  ‘GRUB_BUTTON_CMOS_ADDRESS’ is vendor-specific and partially
model-specific.  Values known to the GRUB team are:

<Dell XPS M1330M>
     121:3
<Dell XPS M1530>
     85:3
<Dell Latitude E4300>
     85:3
<Asus EeePC 1005PE>
     84:1 (unconfirmed)
<LENOVO ThinkPad T410s (2912W1C)>
     101:3

   To take full advantage of this function, install GRUB into the MBR
(see Installing GRUB using grub-install).

   If you have a laptop which has a similar feature and not in the above
list could you figure your address and contribute?  To discover the
address do the following:
   • boot normally
   •      sudo modprobe nvram
          sudo cat /dev/nvram | xxd > normal_button.txt
   • boot using vendor button
   •      sudo modprobe nvram
          sudo cat /dev/nvram | xxd > normal_vendor.txt

   Then compare these text files and find where a bit was toggled.  E.g.
in case of Dell XPS it was:
     byte 0x47: 20 --> 28
   It's a bit number 3 as seen from following table:
0              01
1              02
2              04
3              08
4              10
5              20
6              40
7              80

   0x47 is decimal 71.  Linux nvram implementation cuts first 14 bytes
of CMOS. So the real byte address in CMOS is 71+14=85 So complete
address is 85:3

11 GRUB image files
*******************

GRUB consists of several images: a variety of bootstrap images for
starting GRUB in various ways, a kernel image, and a set of modules
which are combined with the kernel image to form a core image.  Here is
a short overview of them.

‘boot.img’
     On PC BIOS systems, this image is the first part of GRUB to start.
     It is written to a master boot record (MBR) or to the boot sector
     of a partition.  Because a PC boot sector is 512 bytes, the size of
     this image is exactly 512 bytes.

     The sole function of ‘boot.img’ is to read the first sector of the
     core image from a local disk and jump to it.  Because of the size
     restriction, ‘boot.img’ cannot understand any file system
     structure, so ‘grub-install’ hardcodes the location of the first
     sector of the core image into ‘boot.img’ when installing GRUB.

‘diskboot.img’
     This image is used as the first sector of the core image when
     booting from a hard disk.  It reads the rest of the core image into
     memory and starts the kernel.  Since file system handling is not
     yet available, it encodes the location of the core image using a
     block list format.

‘cdboot.img’
     This image is used as the first sector of the core image when
     booting from a CD-ROM drive.  It performs a similar function to
     ‘diskboot.img’.

‘pxeboot.img’
     This image is used as the start of the core image when booting from
     the network using PXE. See Network.

‘lnxboot.img’
     This image may be placed at the start of the core image in order to
     make GRUB look enough like a Linux kernel that it can be booted by
     LILO using an ‘image=’ section.

‘kernel.img’
     This image contains GRUB's basic run-time facilities: frameworks
     for device and file handling, environment variables, the rescue
     mode command-line parser, and so on.  It is rarely used directly,
     but is built into all core images.

‘core.img’
     This is the core image of GRUB. It is built dynamically from the
     kernel image and an arbitrary list of modules by the ‘grub-mkimage’
     program.  Usually, it contains enough modules to access
     ‘/boot/grub’, and loads everything else (including menu handling,
     the ability to load target operating systems, and so on) from the
     file system at run-time.  The modular design allows the core image
     to be kept small, since the areas of disk where it must be
     installed are often as small as 32KB.

     See BIOS installation, for details on where the core image can
     be installed on PC systems.

‘*.mod’
     Everything else in GRUB resides in dynamically loadable modules.
     These are often loaded automatically, or built into the core image
     if they are essential, but may also be loaded manually using the
     ‘insmod’ command (see insmod).

For GRUB Legacy users
=====================

GRUB 2 has a different design from GRUB Legacy, and so correspondences
with the images it used cannot be exact.  Nevertheless, GRUB Legacy
users often ask questions in the terms they are familiar with, and so
here is a brief guide to how GRUB 2's images relate to that.

‘stage1’
     Stage 1 from GRUB Legacy was very similar to ‘boot.img’ in GRUB 2,
     and they serve the same function.

‘*_stage1_5’
     In GRUB Legacy, Stage 1.5's function was to include enough
     filesystem code to allow the much larger Stage 2 to be read from an
     ordinary filesystem.  In this respect, its function was similar to
     ‘core.img’ in GRUB 2.  However, ‘core.img’ is much more capable
     than Stage 1.5 was; since it offers a rescue shell, it is sometimes
     possible to recover manually in the event that it is unable to load
     any other modules, for example if partition numbers have changed.
     ‘core.img’ is built in a more flexible way, allowing GRUB 2 to
     support reading modules from advanced disk types such as LVM and
     RAID.

     GRUB Legacy could run with only Stage 1 and Stage 2 in some limited
     configurations, while GRUB 2 requires ‘core.img’ and cannot work
     without it.

‘stage2’
     GRUB 2 has no single Stage 2 image.  Instead, it loads modules from
     ‘/boot/grub’ at run-time.

‘stage2_eltorito’
     In GRUB 2, images for booting from CD-ROM drives are now
     constructed using ‘cdboot.img’ and ‘core.img’, making sure that the
     core image contains the ‘iso9660’ module.  It is usually best to
     use the ‘grub-mkrescue’ program for this.

‘nbgrub’
     There is as yet no equivalent for ‘nbgrub’ in GRUB 2; it was used
     by Etherboot and some other network boot loaders.

‘pxegrub’
     In GRUB 2, images for PXE network booting are now constructed using
     ‘pxeboot.img’ and ‘core.img’, making sure that the core image
     contains the ‘pxe’ and ‘pxecmd’ modules.  See Network.

12 Core image size limitation
*****************************

Heavily limited platforms:
   • i386-pc (normal and PXE): the core image size (compressed) is
     limited by 458240 bytes.  kernel.img (.text + .data + .bss,
     uncompressed) is limited by 392704 bytes.  module size
     (uncompressed) + kernel.img (.text + .data, uncompressed) is
     limited by the size of contiguous chunk at 1M address.
   • sparc64-ieee1275: kernel.img (.text + .data + .bss) + modules +
     256K (stack) + 2M (heap) is limited by space available at 0x4400.
     On most platforms it's just 3 or 4M since ieee1275 maps only so
     much.
   • i386-ieee1275: kernel.img (.text + .data + .bss) + modules is
     limited by memory available at 0x10000, at most 596K

   Lightly limited platforms:

   • *-xen: limited only by adress space and RAM size.
   • i386-qemu: kernel.img (.text + .data + .bss) is limited by 392704
     bytes.  (core.img would be limited by ROM size but it's unlimited
     on qemu
   • All EFI platforms: limited by contiguous RAM size and possibly
     firmware bugs
   • Coreboot and multiboot.  kernel.img (.text + .data + .bss) is
     limited by 392704 bytes.  module size is limited by the size of
     contiguous chunk at 1M address.
   • mipsel-loongson (ELF), mips(el)-qemu_mips (ELF): if uncompressed:
     kernel.img (.text + .data) + modules is limited by the space from
     80200000 forward if compressed: kernel.img (.text + .data,
     uncompressed) + modules (uncompressed) + (modules + kernel.img
     (.text + .data)) (compressed) + decompressor is limited by the
     space from 80200000 forward
   • mipsel-loongson (Flash), mips(el)-qemu_mips (Flash): kernel.img
     (.text + .data) + modules is limited by the space from 80200000
     forward core.img (final) is limited by flash size (512K on yeeloong
     and fulooong)
   • mips-arc: if uncompressed: kernel.img (.text + .data) is limited by
     the space from 8bd00000 forward modules + dummy decompressor is
     limited by the space from 8bd00000 backward if compressed:
     kernel.img (.text + .data, uncompressed) is limited by the space
     from 8bd00000 forward modules (uncompressed) + (modules +
     kernel.img (.text + .data)) (compressed, aligned to 1M) + 1M
     (decompressor + scratch space) is limited by the space from
     8bd00000 backward
   • powerpc-ieee1275: kernel.img (.text + .data + .bss) + modules is
     limited by space available at 0x200000

13 Filesystem syntax and semantics
**********************************

GRUB uses a special syntax for specifying disk drives which can be
accessed by BIOS. Because of BIOS limitations, GRUB cannot distinguish
between IDE, ESDI, SCSI, or others.  You must know yourself which BIOS
device is equivalent to which OS device.  Normally, that will be clear
if you see the files in a device or use the command ‘search’ (see
search).

13.1 How to specify devices
===========================

The device syntax is like this:

     (DEVICE[,PARTMAP-NAME1PART-NUM1[,PARTMAP-NAME2PART-NUM2[,...]]])

   ‘[]’ means the parameter is optional.  DEVICE depends on the disk
driver in use.  BIOS and EFI disks use either ‘fd’ or ‘hd’ followed by a
digit, like ‘fd0’, or ‘cd’.  AHCI, PATA (ata), crypto, USB use the name
of driver followed by a number.  Memdisk and host are limited to one
disk and so it's referred just by driver name.  RAID (md), ofdisk
(ieee1275 and nand), LVM (lvm), LDM, virtio (vdsk) and arcdisk (arc) use
intrinsic name of disk prefixed by driver name.  Additionally just
"nand" refers to the disk aliased as "nand".  Conflicts are solved by
suffixing a number if necessary.  Commas need to be escaped.  Loopback
uses whatever name specified to ‘loopback’ command.  Hostdisk uses names
specified in device.map as long as it's of the form [fhc]d[0-9]* or
hostdisk/<OS DEVICE>.  For crypto and RAID (md) additionally you can use
the syntax <driver name>uuid/<uuid>.  For LVM additionally you can use
the syntax lvmid/<volume-group-uuid>/<volume-uuid>.

     (fd0)
     (hd0)
     (cd)
     (ahci0)
     (ata0)
     (crypto0)
     (usb0)
     (cryptouuid/123456789abcdef0123456789abcdef0)
     (mduuid/123456789abcdef0123456789abcdef0)
     (lvm/system-root)
     (lvmid/F1ikgD-2RES-306G-il9M-7iwa-4NKW-EbV1NV/eLGuCQ-L4Ka-XUgR-sjtJ-ffch-bajr-fCNfz5)
     (md/myraid)
     (md/0)
     (ieee1275/disk2)
     (ieee1275//pci@1f\,0/ide@d/disk@2)
     (nand)
     (memdisk)
     (host)
     (myloop)
     (hostdisk//dev/sda)

   PART-NUM represents the partition number of DEVICE, starting from
one.  PARTNAME is optional but is recommended since disk may have
several top-level partmaps.  Specifying third and later component you
can access to subpartitions.

   The syntax ‘(hd0)’ represents using the entire disk (or the MBR when
installing GRUB), while the syntax ‘(hd0,1)’ represents using the first
partition of the disk (or the boot sector of the partition when
installing GRUB).

     (hd0,msdos1)
     (hd0,msdos1,msdos5)
     (hd0,msdos1,bsd3)
     (hd0,netbsd1)
     (hd0,gpt1)
     (hd0,1,3)

   If you enabled the network support, the special drives
‘(PROTOCOL[,SERVER])’ are also available.  Supported protocols are
‘http’ and ‘tftp’.  If SERVER is omitted, value of environment variable
‘net_default_server’ is used.  Before using the network drive, you must
initialize the network.  See Network, for more information.

   When using ‘http’ or ‘tftp’, ports other than ‘80’ can be specified
using a colon (‘:’) after the address.  To avoid parsing conflicts, when
using IPv6 addresses with custom ports, the addresses must be enclosed
with square brackets (‘[]’), as is standard practice.

     (http,grub.example.com:31337)
     (http,192.0.2.1:339)
     (http,[2001:db8::1]:11235)

   If you boot GRUB from a CD-ROM, ‘(cd)’ is available.  See Making a GRUB bootable CD-ROM,
for details.

13.2 How to specify files
=========================

There are two ways to specify files, by “absolute file name” and by
“block list”.

   An absolute file name resembles a Unix absolute file name, using ‘/’
for the directory separator (not ‘\’ as in DOS). One example is
‘(hd0,1)/boot/grub/grub.cfg’.  This means the file ‘/boot/grub/grub.cfg’
in the first partition of the first hard disk.  If you omit the device
name in an absolute file name, GRUB uses GRUB's “root device”
implicitly.  So if you set the root device to, say, ‘(hd1,1)’ by the
command ‘set root=(hd1,1)’ (see set), then ‘/boot/kernel’ is the
same as ‘(hd1,1)/boot/kernel’.

   On ZFS filesystem the first path component must be
VOLUME‘@’[SNAPSHOT].  So ‘/rootvol@snap-129/boot/grub/grub.cfg’ refers
to file ‘/boot/grub/grub.cfg’ in snapshot of volume ‘rootvol’ with name
‘snap-129’.  Trailing ‘@’ after volume name is mandatory even if
snapshot name is omitted.

13.3 How to specify block lists
===============================

A block list is used for specifying a file that doesn't appear in the
filesystem, like a chainloader.  The syntax is
‘[OFFSET]+[LENGTH][,[OFFSET]+[LENGTH]]...’.  Here is an example:

     0+100,200+1,300+300,800+

   This represents that GRUB should read blocks 0 through 99, block 200,
blocks 300 through 599, and blocks 800 until the end of the device.  If
you omit an offset, then GRUB assumes the offset is zero.  If the length
is omitted, then GRUB assumes the block list extends until the end of
the device.

   Like the file name syntax (see File name syntax), if a blocklist
does not contain a device name, then GRUB uses GRUB's “root device”.  So
‘(hd0,2)+1’ is the same as ‘+1’ when the root device is ‘(hd0,2)’.

14 GRUB's user interface
************************

GRUB has both a simple menu interface for choosing preset entries from a
configuration file, and a highly flexible command-line for performing
any desired combination of boot commands.

   GRUB looks for its configuration file as soon as it is loaded.  If
one is found, then the full menu interface is activated using whatever
entries were found in the file.  If you choose the “command-line” menu
option, or if the configuration file was not found, then GRUB drops to
the command-line interface.

14.1 The flexible command-line interface
========================================

The command-line interface provides a prompt and after it an editable
text area much like a command-line in Unix or DOS. Each command is
immediately executed after it is entered(1) (1).
The commands (see Commands) are a subset
of those available in the configuration file, used with exactly the same
syntax.

   Cursor movement and editing of the text on the line can be done via a
subset of the functions available in the Bash shell:

<C-f>
<PC right key>
     Move forward one character.

<C-b>
<PC left key>
     Move back one character.

<C-a>
<HOME>
     Move to the start of the line.

<C-e>
<END>
     Move the the end of the line.

<C-d>
<DEL>
     Delete the character underneath the cursor.

<C-h>
<BS>
     Delete the character to the left of the cursor.

<C-k>
     Kill the text from the current cursor position to the end of the
     line.

<C-u>
     Kill backward from the cursor to the beginning of the line.

<C-y>
     Yank the killed text back into the buffer at the cursor.

<C-p>
<PC up key>
     Move up through the history list.

<C-n>
<PC down key>
     Move down through the history list.

   When typing commands interactively, if the cursor is within or before
the first word in the command-line, pressing the <TAB> key (or <C-i>)
will display a listing of the available commands, and if the cursor is
after the first word, the ‘<TAB>’ will provide a completion listing of
disks, partitions, and file names depending on the context.  Note that
to obtain a list of drives, one must open a parenthesis, as ‘root (’.

   Note that you cannot use the completion functionality in the TFTP
filesystem.  This is because TFTP doesn't support file name listing for
the security.

   (1) However, this behavior will be changed in the future version, in
a user-invisible way.

14.2 The simple menu interface
==============================

The menu interface is quite easy to use.  Its commands are both
reasonably intuitive and described on screen.

   Basically, the menu interface provides a list of “boot entries” to
the user to choose from.  Use the arrow keys to select the entry of
choice, then press <RET> to run it.  An optional timeout is available to
boot the default entry (the first one if not set), which is aborted by
pressing any key.

   Commands are available to enter a bare command-line by pressing <c>
(which operates exactly like the non-config-file version of GRUB, but
allows one to return to the menu if desired by pressing <ESC>) or to
edit any of the “boot entries” by pressing <e>.

   If you protect the menu interface with a password (see Security),
all you can do is choose an entry by pressing <RET>, or press <p> to
enter the password.

   Pressing <Ctrl-l> will refresh the menu, which can be useful when
connecting via serial after the menu has been drawn.

14.3 Editing a menu entry
=========================

The menu entry editor looks much like the main menu interface, but the
lines in the menu are individual commands in the selected entry instead
of entry names.

   If an <ESC> is pressed in the editor, it aborts all the changes made
to the configuration entry and returns to the main menu interface.

   Each line in the menu entry can be edited freely, and you can add new
lines by pressing <RET> at the end of a line.  To boot the edited entry,
press <Ctrl-x>.

   Although GRUB unfortunately does not support “undo”, you can do
almost the same thing by just returning to the main menu using <ESC>.

15 GRUB environment variables
*****************************

GRUB supports environment variables which are rather like those offered
by all Unix-like systems.  Environment variables have a name, which is
unique and is usually a short identifier, and a value, which is an
arbitrary string of characters.  They may be set (see set), unset
(see unset), or looked up (see Shell-like scripting) by name.

   A number of environment variables have special meanings to various
parts of GRUB. Others may be used freely in GRUB configuration files.

15.1 Special environment variables
==================================

These variables have special meaning to GRUB.

15.1.1 biosnum
--------------

When chain-loading another boot loader (see Chain-loading), GRUB may
need to know what BIOS drive number corresponds to the root device
(see root) so that it can set up registers properly.  If the BIOSNUM
variable is set, it overrides GRUB's own means of guessing this.

   For an alternative approach which also changes BIOS drive mappings
for the chain-loaded system, see drivemap.

15.1.2 check_signatures
-----------------------

This variable controls whether GRUB enforces digital signature
validation on loaded files.  See Using digital signatures.

15.1.3 chosen
-------------

When executing a menu entry, GRUB sets the CHOSEN variable to the title
of the entry being executed.

   If the menu entry is in one or more submenus, then CHOSEN is set to
the titles of each of the submenus starting from the top level followed
by the title of the menu entry itself, separated by ‘>’.

15.1.4 cmdpath
--------------

The location from which ‘core.img’ was loaded as an absolute directory
name (see File name syntax).  This is set by GRUB at startup based
on information returned by platform firmware.  Not every platform
provides this information and some may return only device without path
name.

15.1.5 color_highlight
----------------------

This variable contains the "highlight" foreground and background
terminal colors, separated by a slash (‘/’).  Setting this variable
changes those colors.  For the available color names, see
color_normal.

   The default is ‘black/light-gray’.

15.1.6 color_normal
-------------------

This variable contains the "normal" foreground and background terminal
colors, separated by a slash (‘/’).  Setting this variable changes those
colors.  Each color must be a name from the following list:

   • black
   • blue
   • green
   • cyan
   • red
   • magenta
   • brown
   • light-gray
   • dark-gray
   • light-blue
   • light-green
   • light-cyan
   • light-red
   • light-magenta
   • yellow
   • white

   The default is ‘light-gray/black’.

   The color support support varies from terminal to terminal.

   ‘morse’ has no color support at all.

   ‘mda_text’ color support is limited to highlighting by black/white
reversal.

   ‘console’ on ARC, EMU and IEEE1275, ‘serial_*’ and ‘spkmodem’ are
governed by terminfo and support only 8 colors if in modes ‘vt100-color’
(default for console on emu), ‘arc’ (default for console on ARC),
‘ieee1275’ (default for console on IEEE1275).  When in mode ‘vt100’ then
the color support is limited to highlighting by black/white reversal.
When in mode ‘dumb’ there is no color support.

   When console supports no colors this setting is ignored.  When
console supports 8 colors, then the colors from the second half of the
previous list are mapped to the matching colors of first half.

   ‘console’ on EFI and BIOS and ‘vga_text’ support all 16 colors.

   ‘gfxterm’ supports all 16 colors and would be theoretically
extendable to support whole rgb24 palette but currently there is no
compelling reason to go beyond the current 16 colors.

15.1.7 config_directory
-----------------------

This variable is automatically set by GRUB to the directory part of
current configuration file name (see config_file).

15.1.8 config_file
------------------

This variable is automatically set by GRUB to the name of configuration
file that is being processed by commands ‘configfile’ (see
configfile) or ‘normal’ (see normal).  It is restored to the
previous value when command completes.

15.1.9 cryptodisk_passphrase_tries
----------------------------------

When prompting the user for a cryptodisk passphrase, allow this many
attempts before giving up.  Defaults to ‘3’ if unset or set to an
invalid value.  (The user can give up early by entering an empty
passphrase.)

15.1.10 debug
-------------

This variable may be set to enable debugging output from various
components of GRUB. The value is an ordered list of debug facility names
separated by whitespace or ‘,’.  If the special facility named ‘all’ is
present then debugging output of all facility names is enabled at the
start of processing the value of this variable.  A facility's debug
output can then be disabled by prefixing its name with a ‘-’.  The last
occurence facility name with or without a leading ‘-’ takes precendent
over any previous occurence.  This allows the easy enabling or disabling
of facilities by appending a ‘,’ and then the facility name with or
without the leading ‘-’, which will preserve the state of the rest of
the facilities.  The facility names are the first argument to
grub_dprintf.  Consult the source for more details.

15.1.11 default
---------------

If this variable is set, it identifies a menu entry that should be
selected by default, possibly after a timeout (see timeout).  The
entry may be identified by number (starting from 0 at each level of the
hierarchy), by title, or by id.

   For example, if you have:

menuentry 'Example GNU/Linux distribution' --class gnu-linux --id example-gnu-linux {
	...
}

   then you can make this the default using:

     default=example-gnu-linux

   If the entry is in a submenu, then it must be identified using the
number, title, or id of each of the submenus starting from the top
level, followed by the number, title, or id of the menu entry itself,
with each element separated by ‘>’.  For example, take the following
menu structure:

     GNU/Hurd --id gnu-hurd
       Standard Boot --id=gnu-hurd-std
       Rescue shell --id=gnu-hurd-rescue
     Other platforms --id=other
       Minix --id=minix
         Version 3.4.0 --id=minix-3.4.0
         Version 3.3.0 --id=minix-3.3.0
       GRUB Invaders --id=grub-invaders

   The more recent release of Minix would then be identified as ‘Other
platforms>Minix>Version 3.4.0’, or as ‘1>0>0’, or as
‘other>minix>minix-3.4.0’.

   This variable is often set by ‘GRUB_DEFAULT’ (see Simple configuration),
‘grub-set-default’, or ‘grub-reboot’.

15.1.12 fallback
----------------

If this variable is set, it identifies a menu entry that should be
selected if the default menu entry fails to boot.  Entries are
identified in the same way as for ‘default’ (see default).

15.1.13 gfxmode
---------------

If this variable is set, it sets the resolution used on the ‘gfxterm’
graphical terminal.  Note that you can only use modes which your
graphics card supports via VESA BIOS Extensions (VBE), so for example
native LCD panel resolutions may not be available.  The default is
‘auto’, which selects a platform-specific default that should look
reasonable.  Supported modes can be listed by ‘videoinfo’ command in
GRUB.

   The resolution may be specified as a sequence of one or more modes,
separated by commas (‘,’) or semicolons (‘;’); each will be tried in
turn until one is found.  Each mode should be either ‘auto’,
‘WIDTHxHEIGHT’, or ‘WIDTHxHEIGHTxDEPTH’.

15.1.14 gfxpayload
------------------

If this variable is set, it controls the video mode in which the Linux
kernel starts up, replacing the ‘vga=’ boot option (see linux).  It
may be set to ‘text’ to force the Linux kernel to boot in normal text
mode, ‘keep’ to preserve the graphics mode set using ‘gfxmode’, or any
of the permitted values for ‘gfxmode’ to set a particular graphics mode
(see gfxmode).

   Depending on your kernel, your distribution, your graphics card, and
the phase of the moon, note that using this option may cause GNU/Linux
to suffer from various display problems, particularly during the early
part of the boot sequence.  If you have problems, set this variable to
‘text’ and GRUB will tell Linux to boot in normal text mode.

   The default is platform-specific.  On platforms with a native text
mode (such as PC BIOS platforms), the default is ‘text’.  Otherwise the
default may be ‘auto’ or a specific video mode.

   This variable is often set by ‘GRUB_GFXPAYLOAD_LINUX’ (see Simple configuration).

15.1.15 gfxterm_font
--------------------

If this variable is set, it names a font to use for text on the
‘gfxterm’ graphical terminal.  Otherwise, ‘gfxterm’ may use any
available font.

15.1.16 grub_cpu
----------------

In normal mode (see normal), GRUB sets the ‘grub_cpu’ variable to
the CPU type for which GRUB was built (e.g.  ‘i386’ or ‘powerpc’).

15.1.17 grub_platform
---------------------

In normal mode (see normal), GRUB sets the ‘grub_platform’ variable
to the platform for which GRUB was built (e.g.  ‘pc’ or ‘efi’).

15.1.18 icondir
---------------

If this variable is set, it names a directory in which the GRUB
graphical menu should look for icons after looking in the theme's
‘icons’ directory.  See Theme file format.

15.1.19 lang
------------

If this variable is set, it names the language code that the ‘gettext’
command (see gettext) uses to translate strings.  For example,
French would be named as ‘fr’, and Simplified Chinese as ‘zh_CN’.

   ‘grub-mkconfig’ (see Simple configuration) will try to set a
reasonable default for this variable based on the system locale.

15.1.20 locale_dir
------------------

If this variable is set, it names the directory where translation files
may be found (see gettext), usually ‘/boot/grub/locale’.  Otherwise,
internationalization is disabled.

   ‘grub-mkconfig’ (see Simple configuration) will set a reasonable
default for this variable if internationalization is needed and any
translation files are available.

15.1.21 lockdown
----------------

If this variable is set to ‘y’, it means that GRUB has entered
Lockdown mode.

15.1.22 menu_color_highlight
----------------------------

This variable contains the foreground and background colors to be used
for the highlighted menu entry, separated by a slash (‘/’).  Setting
this variable changes those colors.  For the available color names,
see color_normal.

   The default is the value of ‘color_highlight’ (see
color_highlight).

15.1.23 menu_color_normal
-------------------------

This variable contains the foreground and background colors to be used
for non-highlighted menu entries, separated by a slash (‘/’).  Setting
this variable changes those colors.  For the available color names,
see color_normal.

   The default is the value of ‘color_normal’ (see color_normal).

15.1.24 net_<INTERFACE>_boot_file
---------------------------------

See Network.

15.1.25 net_<INTERFACE>_clientid
--------------------------------

See Network.

15.1.26 net_<INTERFACE>_clientuuid
----------------------------------

See Network.

15.1.27 net_<INTERFACE>_dhcp_server_name
----------------------------------------

See Network.

15.1.28 net_<INTERFACE>_domain
------------------------------

See Network.

15.1.29 net_<INTERFACE>_extensionspath
--------------------------------------

See Network.

15.1.30 net_<INTERFACE>_hostname
--------------------------------

See Network.

15.1.31 net_<INTERFACE>_ip
--------------------------

See Network.

15.1.32 net_<INTERFACE>_mac
---------------------------

See Network.

15.1.33 net_<INTERFACE>_next_server
-----------------------------------

See Network.

15.1.34 net_<INTERFACE>_rootpath
--------------------------------

See Network.

15.1.35 net_default_interface
-----------------------------

See Network.

15.1.36 net_default_ip
----------------------

See Network.

15.1.37 net_default_mac
-----------------------

See Network.

15.1.38 net_default_server
--------------------------

See Network.

15.1.39 pager
-------------

If set to ‘1’, pause output after each screenful and wait for keyboard
input.  The default is not to pause output.

15.1.40 prefix
--------------

The location of the ‘/boot/grub’ directory as an absolute file name
(see File name syntax).  This is normally set by GRUB at startup
based on information provided by ‘grub-install’.  GRUB modules are
dynamically loaded from this directory, so it must be set correctly in
order for many parts of GRUB to work.

15.1.41 pxe_default_server
--------------------------

See Network.

15.1.42 root
------------

The root device name (see Device syntax).  Any file names that do
not specify an explicit device name are read from this device.  The
default is normally set by GRUB at startup based on the value of
‘prefix’ (see prefix).

   For example, if GRUB was installed to the first partition of the
first hard disk, then ‘prefix’ might be set to ‘(hd0,msdos1)/boot/grub’
and ‘root’ to ‘hd0,msdos1’.

15.1.43 shim_lock
-----------------

If this variable is set to ‘y’, it means that the shim_lock verifier is
registered (see UEFI secure boot and shim).

15.1.44 superusers
------------------

This variable may be set to a list of superuser names to enable
authentication support.  See Security.

15.1.45 theme
-------------

This variable may be set to a directory containing a GRUB graphical menu
theme.  See Theme file format.

   This variable is often set by ‘GRUB_THEME’ (see Simple configuration).

15.1.46 timeout
---------------

If this variable is set, it specifies the time in seconds to wait for
keyboard input before booting the default menu entry.  A timeout of ‘0’
means to boot the default entry immediately without displaying the menu;
a timeout of ‘-1’ (or unset) means to wait indefinitely.

   If ‘timeout_style’ (see timeout_style) is set to ‘countdown’ or
‘hidden’, the timeout is instead counted before the menu is displayed.

   This variable is often set by ‘GRUB_TIMEOUT’ (see Simple configuration).

15.1.47 timeout_style
---------------------

This variable may be set to ‘menu’, ‘countdown’, or ‘hidden’ to control
the way in which the timeout (see timeout) interacts with displaying
the menu.  See the documentation of ‘GRUB_TIMEOUT_STYLE’ (see Simple configuration)
for details.

15.1.48 tpm_fail_fatal
----------------------

If this variable is set and true (i.e., not set to "0", "false",
"disable", or "no"), TPM measurements that fail will be treated as
fatal.  Otherwise, they will merely be debug-logged and boot will
continue.

   Call to EFI firmware, like hash_log_extend_event(), can return an
unknown error, i.e.  due to bug present in firmware.  When this variable
is set and true (same values as with TPM measurements) this situation
will be considered to be fatal and error-logged as "unknown TPM error".
If not set, booting the OS will be enabled.

15.2 The GRUB environment block
===============================

It is often useful to be able to remember a small amount of information
from one boot to the next.  For example, you might want to set the
default menu entry based on what was selected the last time.  GRUB
deliberately does not implement support for writing files in order to
minimise the possibility of the boot loader being responsible for file
system corruption, so a GRUB configuration file cannot just create a
file in the ordinary way.  However, GRUB provides an "environment block"
which can be used to save a small amount of state.

   The environment block is a preallocated 1024-byte file, which
normally lives in ‘/boot/grub/grubenv’ (although you should not assume
this).  At boot time, the ‘load_env’ command (see load_env) loads
environment variables from it, and the ‘save_env’ (see save_env)
command saves environment variables to it.  From a running system, the
‘grub-editenv’ utility can be used to edit the environment block.

   For safety reasons, this storage is only available when installed on
a plain disk (no LVM or RAID), using a non-checksumming filesystem (no
ZFS), and using BIOS or EFI functions (no ATA, USB or IEEE1275).

   ‘grub-mkconfig’ uses this facility to implement ‘GRUB_SAVEDEFAULT’
(see Simple configuration).

16 Modules
**********

In this chapter, we list all modules that are available in GRUB.

   Modules can be loaded via the ‘insmod’ (see insmod) command.

16.1 acpi
=========

This module provides the command ‘acpi’ for loading / replacing Advanced
Configuration and Power Interface (ACPI) tables.  Please acpi
for more information.

16.2 adler32
============

This module provides the library implementation for the adler32
checksum.  This is used as part of LZO decompression / compression.

16.3 affs
=========

This module provides support for the Amiga Fast FileSystem (AFFS). Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.4 afs
========

This module provides support for the AtheOS File System (AFS). Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.5 afsplitter
===============

This module provides library support for the Anti forensic information
splitter (AFS) operation ‘AF_merge’.  This is used by LUKS and LUKS2.

16.6 ahci
=========

This module provides support for the Advanced Host Controller Interface
protocol to access disks supporting this standard.  AHCI is often an
option for Serial ATA (SATA) controllers (meant to replace the older IDE
protocol).

16.7 all_video
==============

This is a "dummy module" with no actual function except to load all
other video modules as dependencies (a convenient way to load all video
modules).

16.8 aout
=========

This module provides support for loading files packaged in the "a.out"
format.  The "a.out" format is considered to be an older format than
some alternatives such as "ELF", for example support for the "a.out"
format was removed from the Linux kernel in 5.18.

16.9 appleldr
=============

This module provides support for loading files on a BIOS / EFI based
Apple Mac computer (Intel based Macs).

16.10 archelp
=============

This module provides Archive Helper functions for archive based file
systems such as TAR and CPIO archives.

16.11 at_keyboard
=================

This module provides support for the AT keyboard input for the GRUB
terminal.

16.12 ata
=========

This modules provides support for direct ATA and ATAPI access to
compatible disks.

16.13 backtrace
===============

This module provides the command ‘backtrace’ for printing a backtrace to
the terminal for the current call stack.

16.14 bfs
=========

This module provides support for the BeOS "Be File System" (BFS). Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.15 biosdisk
==============

This module provides support for booting from a bootable removable disk
such as a CD-ROM, BD-ROM, etc.

16.16 bitmap
============

This module provides support for reading and interacting with bitmap
image files.

16.17 bitmap_scale
==================

This module provides support for scaling bitmap image files.

16.18 bli
=========

This module provides basic support for the Boot Loader Interface.  The
Boot Loader Interface specifies a set of EFI variables that are used to
communicate boot-time information between the bootloader and the
operating system.

   The following variables are placed under the vendor UUID
‘4a67b082-0a4c-41cf-b6c7-440b29bb8c4f’ when the module is loaded:

   The GPT partition UUID of the EFI System Partition used during boot
is published via the ‘LoaderDevicePartUUID’ variable.  The Boot Loader
Interface specification requires GPT formatted drives.  The bli module
ignores drives/partitions in any other format.  If GRUB is loaded from a
non-GPT partition, e.g.  from an MSDOS formatted drive or network, this
variable will not be set.

   A string identifying GRUB as the active bootloader including the
version number is stored in ‘LoaderInfo’.

   This module is only available on UEFI platforms.

16.19 blocklist
===============

This module provides support for the command ‘blocklist’ to list blocks
for a given file.  Please blocklist for more information.

16.20 boot
==========

This module provides support for the command ‘boot’ to boot an operating
system.  Please boot for more information.

16.21 boottime
==============

This module provides support for the command ‘boottime’ to display time
taken to perform various GRUB operations.  This module is only available
when GRUB is built with the conditional compile option
‘BOOT_TIME_STATS’.

16.22 bsd
=========

This module provides support for loading BSD operating system images via
commands such as: ‘kfreebsd_loadenv’, ‘kfreebsd_module_elf’,
‘kfreebsd_module’, ‘kfreebsd’, ‘knetbsd_module_elf’, ‘knetbsd_module’,
‘knetbsd’, ‘kopenbsd’, and ‘kopenbsd_ramdisk’.  Please Loader commands
for more info.

16.23 bswap_test
================

This module is intended for performing a functional test of the byte
swapping functionality of GRUB.

16.24 btrfs
===========

This module provides support for the B-Tree File System (BTRFS).

16.25 bufio
===========

This module is a library module for support buffered I/O of files to
support file reads performed in other modules.

16.26 cacheinfo
===============

This module provides support for the command ‘cacheinfo’ which provides
statistics on disk cache accesses.  This module is only built if
‘DISK_CACHE_STATS’ is enabled.

16.27 cat
=========

This module provides support for the command ‘cat’ which outputs the
content of a file to the terminal.  Please cat for more info.

16.28 cbfs
==========

This module provides support for the Coreboot File System (CBFS) which
is an archive based file system.  Note: This module is not allowed in
lockdown mode, see Lockdown for more information.

16.29 cbls
==========

This module provides support for the command ‘lscoreboot’ to list the
Coreboot tables.

16.30 cbmemc
============

This module provides support for the command ‘cbmemc’ to show the
content of the Coreboot Memory console.

16.31 cbtable
=============

This module provides support for accessing the Coreboot tables.

16.32 cbtime
============

This module provides support for the command ‘coreboot_boottime’ to show
the Coreboot boot time statistics.

16.33 chain
===========

This module provides support for the command ‘chainloader’ to boot
another bootloader.  Please chainloader for more information.

16.34 cmdline_cat_test
======================

This module is intended for performing a functional test of the ‘cat’
command of GRUB.

16.35 cmosdump
==============

This module provides support for the command ‘cmosdump’ to show a raw
dump of the CMOS contents.  Please cmosdump for more
information.

16.36 cmostest
==============

This module provides support for the commands ‘cmostest’, ‘cmosclean’,
and ‘cmosset’ to interact with a CMOS. See cmostest / see
cmosclean for more information.

16.37 cmp
=========

This module provides support for the command ‘cmp’ to compare the
content of two files.  See cmp for more information.

16.38 cmp_test
==============

This module is intended for performing a functional test of relational
operations in GRUB. Note that this module is *not* associated with the
‘cmp’ command and does not test the ‘cmp’ command.

16.39 configfile
================

This module provides support for the commands: ‘configfile’, ‘source’,
‘extract_entries_source’, ‘extract_entries_configfile’, ‘.’ (dot
command).  See configfile / see source.

16.40 cpio
==========

This module provides support for the CPIO archive file format.  This
module is for the "bin" version of CPIO (default of GNU CPIO) supporting
around 2GB.

16.41 cpio_be
=============

This module provides support for the CPIO archive file format in
big-endian format.  This module is for the "bin" version of CPIO
(default of GNU CPIO) supporting around 2GB.

16.42 cpuid
===========

This module provides support for the command ‘cpuid’ to test for various
CPU features.  See cpuid for more information.

16.43 crc64
===========

This module provides support for the CRC64 operation.

16.44 crypto
============

This module provides library support for various base cryptography
operations in GRUB.

16.45 cryptodisk
================

This module provides support for the command ‘cryptomount’ to interact
with encrypted file systems.  See cryptomount for more information.

16.46 cs5536
============

This module provides support for the AMD Geode CS5536 companion device.

16.47 ctz_test
==============

This module is intended for performing a functional test of the ctz
functions in GRUB used to Count Trailing Zeros.

16.48 date
==========

This module provides support for the command ‘date’ to get the date/time
or set the date/time.  See date for more information.

16.49 datehook
==============

This module provides support for populating / providing the environment
variables ‘YEAR’, ‘MONTH’, ‘DAY’, ‘HOUR’, ‘MINUTE’, ‘SECOND’, ‘WEEKDAY’.

16.50 datetime
==============

This module provides library support for getting and setting the date /
time from / to a hardware clock device.

16.51 disk
==========

This module provides library support for writing to a storage disk.

16.52 diskfilter
================

This module provides library support for reading a disk RAID array.  It
also provides support for the command ‘cryptocheck’.  See
cryptocheck for more information.

16.53 div
=========

This module provides library support for some operations such as divmod.

16.54 div_test
==============

This module is intended for performing a functional test of the divmod
function in GRUB.

16.55 dm_nv
===========

This module provides support for handling some Nvidia "fakeraid" disk
devices.

16.56 drivemap
==============

This module provides support for the ‘drivemap’ to manage BIOS drive
mappings.  See drivemap for more information.

16.57 echo
==========

This module provides support for the ‘echo’ to display a line of text.
See echo for more information.

16.58 efi_gop
=============

This module provides support for the UEFI video output protocol
"Graphics Output Protocol" (GOP).

16.59 efi_uga
=============

This module provides support for the EFI video protocol "Universal
Graphic Adapter" (UGA).

16.60 efiemu
============

This module provides support for the commands ‘efiemu_loadcore’,
‘efiemu_prepare’, and ‘efiemu_unload’.  This provides an EFI emulation.

16.61 efifwsetup
================

This modules provides support for the command ‘fwsetup’ to reboot into
the firmware setup menu.  See fwsetup for more information.

16.62 efinet
============

This module provides support for UEFI Network Booting for loading images
and data from the network.

16.63 efitextmode
=================

This module provides support for command ‘efitextmode’ to get and set
output mode resolution.  See efitextmode for more information.

16.64 ehci
==========

This module provides support for the USB Enhanced Host Controller
Interface (EHCI) specification (USB 2.0).

16.65 elf
=========

This module provides support for loading Executable and Linkable Format
(ELF) files.

16.66 emunet
============

This module provides support for networking in GRUB on the emu platform.

16.67 emupci
============

This module provides support for accessing the PCI bus in GRUB on the
emu platform.

16.68 erofs
===========

This module provides support for the Enhanced Read Only File System
(EROFS).

16.69 escc
==========

This module provides support for the "mac-io" terminal device on
PowerPC.

16.70 eval
==========

This module provides support for command ‘eval’ to evaluate the provided
input as a sequence of GRUB commands.  See eval for more
information.

16.71 exfat
===========

This module provides support for the Extensible File Allocation Table
(exFAT) file system in GRUB.

16.72 exfctest
==============

This module is intended to provide an Example Functional Test of GRUB
functions to use as a template for developing other GRUB functional
tests.

16.73 ext2
==========

This module provides support for the Extended File System versions 2, 3,
and 4 (ext2, ext3, and ext4) file systems in GRUB.

16.74 extcmd
============

This module is a support module to provide wrapper functions for
registering other module commands depending on the state of the lockdown
variable.

16.75 f2fs
==========

This module provides support for the Flash-Friendly File System (F2FS)
in GRUB.

16.76 fat
=========

This module provides support for the File Allocation Table 12-bit,
16-bit, and 32-bit (FAT12, FAT16, and FAT32) file systems in GRUB.

16.77 fdt
=========

This module provides support for the commands ‘fdtdump’ and ‘devicetree’
to dump the contents of a device tree blob (.dtb) to the console and to
load a device tree blob (.dtb) from a filesystem, for later use by a
Linux kernel, respectively.  See devicetree and fdtdump for
more information.

16.78 file
==========

This module provides support for the command ‘file’ to test if the
provided filename is of the specified type.  See file for more
information.

16.79 fixvideo
==============

This module provides support for the command ‘fix_video’ to fix video
problems in specific PCIe video devices by "patching" specific device
register settings.  Currently supports Intel 945GM (PCI ID ‘0x27a28086’)
and Intel 965GM (PCI ID ‘0x2a028086’).

16.80 font
==========

This module provides support for the commands ‘loadfont’ and ‘lsfonts’
to load a given font or list the loaded fonts.  See loadfont and
lsfonts for more information.

16.81 freedos
=============

This module provides support for command ‘freedos’ for loading a FreeDOS
kernel.

16.82 fshelp
============

This module provides support functions (helper functions) for file
systems.

16.83 functional_test
=====================

This module provides support for running the GRUB functional tests using
commands ‘functional_test’ and ‘all_functional_test’.

16.84 gcry_arcfour
==================

This module provides support for the arcfour stream cipher also known as
RC4.  If security is a concern, RC4 / arcfour cipher is consider broken
(multiple known vulnerabilities make this insecure).  This GRUB module
is based on libgcrypt.

16.85 gcry_blowfish
===================

This module provides support for the Blowfish cipher.  This GRUB module
is based on libgcrypt.

16.86 gcry_camellia
===================

This module provides support for the Camellia cipher.  This GRUB module
is based on libgcrypt.

16.87 gcry_cast5
================

This module provides support for the CAST5 (RFC2144, also known as
CAST-128) cipher.  This GRUB module is based on libgcrypt.

16.88 gcry_crc
==============

This module provides support for the CRC32, CRC32 RFC1510, and CRC24
RFC2440 cyclic redundancy checks.  This GRUB module is based on
libgcrypt.

16.89 gcry_des
==============

This module provides support for the Data Encryption Standard (DES) and
Triple-DES ciphers.  If security is a concern, DES has known
vulnerabilities and is not recommended, and Triple-DES is no longer
recommended by NIST. This GRUB module is based on libgcrypt.

16.90 gcry_dsa
==============

This module provides support for the Digital Signature Algorithm (DSA)
cipher.  This GRUB module is based on libgcrypt.

16.91 gcry_idea
===============

This module provides support for the International Data Encryption
Algorithm (IDEA) cipher.  This GRUB module is based on libgcrypt.

16.92 gcry_md4
==============

This module provides support for the Message Digest 4 (MD4) message
digest.  If security is a concern, MD4 has known vulnerabilities and is
not recommended.  This GRUB module is based on libgcrypt.

16.93 gcry_md5
==============

This module provides support for the Message Digest 5 (MD5) message
digest.  If security is a concern, MD5 has known vulnerabilities and is
not recommended.  This GRUB module is based on libgcrypt.

16.94 gcry_rfc2268
==================

This module provides support for the RFC2268 (RC2 / Ron's Cipher 2)
cipher.  If security is a concern, RC2 has known vulnerabilities and is
not recommended.  This GRUB module is based on libgcrypt.

16.95 gcry_rijndael
===================

This module provides support for the Advanced Encryption Standard
(AES-128, AES-192, and AES-256) ciphers.  This GRUB module is based on
libgcrypt.

16.96 gcry_rmd160
=================

This module provides support for the RIPEMD-160 message digest.  This
GRUB module is based on libgcrypt.

16.97 gcry_rsa
==============

This module provides support for the Rivest–Shamir–Adleman (RSA) cipher.
This GRUB module is based on libgcrypt.

16.98 gcry_seed
===============

This module provides support for the SEED cipher.  This GRUB module is
based on libgcrypt.

16.99 gcry_serpent
==================

This module provides support for the Serpent (128, 192, and 256)
ciphers.  This GRUB module is based on libgcrypt.

16.100 gcry_sha1
================

This module provides support for the Secure Hash Algorithm 1 (SHA-1)
message digest.  If security is a concern, SHA-1 has known
vulnerabilities and is not recommended.  This GRUB module is based on
libgcrypt.

16.101 gcry_sha256
==================

This module provides support for the Secure Hash Algorithm 2 (224 and
256 bit) (SHA-224 / SHA-256) message digests.  This GRUB module is based
on libgcrypt.

16.102 gcry_sha512
==================

This module provides support for the Secure Hash Algorithm 2 (384 and
512 bit) (SHA-384 / SHA-512) message digests.  This GRUB module is based
on libgcrypt.

16.103 gcry_tiger
=================

This module provides support for the Tiger, Tiger 1, and Tiger 2 message
digests.  This GRUB module is based on libgcrypt.

16.104 gcry_twofish
===================

This module provides support for the Twofish (128 and 256) ciphers.
This GRUB module is based on libgcrypt.

16.105 gcry_whirlpool
=====================

This module provides support for the Whirlpool message digest.  This
GRUB module is based on libgcrypt.

16.106 gdb
==========

This module provides support for remotely debugging GRUB using the GNU
Debugger (GDB) over serial.  This is typically done when troubleshooting
GRUB during development and not required for normal GRUB operation.
This module adds support for commands required by the GDB remote debug
function including ‘gdbstub’ to start GDB stub on given serial port,
‘gdbstub_break’ to break into GDB, ‘gdbstub_stop’ to stop the GDB stub.

16.107 geli
===========

This module provides support for the GEOM ELI (GELI) disk encryption /
decryption protocol used by FreeBSD. This module supports the following
ciphers using the associated "gcry" modules: DES, Triple-DES, Blowfish,
CAST5, AES, and Camellia 128.

16.108 gettext
==============

This module provides support for the ‘gettext’ command to support
translating information displayed / output by GRUB. See gettext for
more information.

16.109 gfxmenu
==============

This module provides support for displaying a graphical menu / user
interface from GRUB. This includes features such as graphical font
support, theme support, image support, and icon support.

16.110 gfxterm
==============

This module provides support for displaying a terminal and menu
interface from GRUB using graphics mode.

16.111 gfxterm_background
=========================

This module provides support for setting the gfxterm background color
and background image using commands ‘background_color’ and
‘background_image’.  See background_color and
background_image for more information.

16.112 gfxterm_menu
===================

This module is intended for performing a functional test of the gfxmenu
function in GRUB.

16.113 gptsync
==============

This module provides support for the ‘gptsync’ command..  See
gptsync for more information.

16.114 gzio
===========

This module provides support for decompression (inflate) of files
compressed with the GZ compression algorithm.  This supports only the
"DEFLATE" method for GZIP. Unsupported flags (will result in failure to
inflate) include: ‘GRUB_GZ_CONTINUATION’, ‘GRUB_GZ_ENCRYPTED’,
‘GRUB_GZ_RESERVED’, and ‘GRUB_GZ_EXTRA_FIELD’.

16.115 halt
===========

This module provides support for the ‘halt’ command to shutdown / halt
the system.  See halt for more information.

16.116 hashsum
==============

This module provide support for the commands ‘hashsum’, ‘md5sum’,
‘sha1sum’, ‘sha256sum’, ‘sha512sum’, and ‘crc’ to calculate or check
hashes of files using various methods.  See hashsum, md5sum
See sha1sum, sha256sum, sha512sum, and crc.

16.117 hdparm
=============

This module provides support for the ‘hdparm’ command to get or set
various ATA disk parameters.  This includes controlling Advanced Power
Management (APM), displaying power mode, freezing ATA security settings
until reset, displaying SMART status, controlling automatic acoustic
management, setting standby timeout, setting the drive to standby mode,
setting the drive to sleep mode, displaying the drive identification and
settings, and enable/disable SMART.

16.118 hello
============

This provides support for the ‘hello’ command to simply output "Hello
World".  This is intended for testing GRUB module loading /
functionality.

16.119 help
===========

This module provides support for the ‘help’ command to output help text.
See help for more information.

16.120 hexdump
==============

This module provides support for the ‘hexdump’ command to dump the
contents of a file in hexadecimal.  See hexdump for more
information.

16.121 hfs
==========

This module provides support for the Hierarchical File System (HFS) file
system in GRUB. Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.122 hfsplus
==============

This module provides support for the Hierarchical File System Plus
(HFS+) file system in GRUB.

16.123 hfspluscomp
==================

This module provides support for the Hierarchical File System Plus
Compressed (HFS+ Compressed) file system in GRUB.

16.124 http
===========

This module provides support for getting data over the HTTP network
protocol in GRUB (using the HTTP GET method).  This may be used, for
example, to obtain an operating system over HTTP (network boot).

16.125 ieee1275_fb
==================

This module provides support for the IEEE1275 video driver output for
PowerPC with a IEEE-1275 platform.

16.126 iorw
===========

This module provides support for commands ‘inb’, ‘inw’, ‘inl’, ‘outb’,
‘outw’, and ‘outl’ to read / write data to physical I/O ports.  The "in"
commands accept one parameter to specify the source port.  The "out"
commands require either two or three parameters, with the order: port,
value, <optional mask>.

16.127 iso9660
==============

This module provides support for the ISO9660 file system (often
associated with optical disks such as CD-ROMs and DVD-ROMs, with
extensions: System Use Sharing Protocol (SUSP), Rock Ridge (UNIX style
permissions and longer names)

16.128 jfs
==========

This module provides support for the Journaled File System (JFS) file
system.  Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.129 jpeg
===========

This module provides support for reading JPEG image files in GRUB, such
as to support displaying a JPEG image as a background image of the
gfxmenu.

16.130 json
===========

This module provides library support for parsing / processing JavaScript
Object Notation (JSON) formatted data.  This is used, for example, to
support LUKS2 disk encryption / decryption as metadata is encoded in
JSON.

16.131 keylayouts
=================

This module provides support for the ‘keymap’ command.  This command
accepts one parameter to specify either the LAYOUT_NAME or the FILENAME.
When specifying the LAYOUT_NAME, this command will attempt to open the
GRUB keymap file based on the following logic:

   Get the "prefix" from environment variable PREFIX

   Open keymap file PREFIX/layouts/LAYOUT_NAME.gkb

   When specifying the FILENAME, the full path to the ".gkb" file should
be provided.  The ".gkb" file can be generated by grub-kbdcomp.

16.132 keystatus
================

This module provides support for the ‘keystatus’ command to check key
modifier status.  See keystatus for more information.

16.133 ldm
==========

This module provides support for the Logical Disk Manager (LDM) disk
format.  LDM is used to add support for logical volumes most often with
Microsoft Windows systems.  A logical volume can be defined to span more
than one physical disk.

16.134 legacy_password_test
===========================

This module is intended for performing a functional test of the legacy
password function in GRUB.

16.135 legacycfg
================

This module provides support for commands ‘legacy_source’,
‘legacy_configfile’, ‘extract_legacy_entries_source’,
‘extract_legacy_entries_configfile’, ‘legacy_kernel’, ‘legacy_initrd’,
‘legacy_initrd_nounzip’, ‘legacy_password’, and ‘legacy_check_password’.
For new uses / configurations of GRUB other commands / modules offer the
modern equivalents.

16.136 linux
============

This module provides support for the commands ‘linux’ and ‘initrd’ to
load Linux and an Initial RAM Disk respectively.  See linux and
initrd for more information.

16.137 linux16
==============

This module provides support for the commands ‘linux16’ and ‘initrd16’
to load Linux in 16-bit mode and an Initial RAM Disk in 16-bit mode
respectively.  See linux16 and initrd16 for more
information.

16.138 loadbios
===============

This module provides support for the commands ‘fakebios’ and ‘loadbios’.
These commands may only be useful on platforms with issues requiring
work-arounds.  Command ‘fakebios’ is used to create BIOS-like structures
for backward compatibility with existing OS. Command ‘loadbios’ is used
to load a BIOS dump.

16.139 loadenv
==============

This module provides support for commands ‘load_env’, ‘list_env’, and
‘save_env’.  These commands can be used to load environment variables
from a file, list environment variables in a file, and save environment
variables to a file.  See load_env, list_env, and
save_env.

16.140 loopback
===============

This module provides support for the ‘loopback’ command.  See
loopback for more information.

16.141 ls
=========

This module provides support for the ‘ls’ command.  See ls for more
information.

16.142 lsacpi
=============

This module provides support for the ‘lsacpi’ command.  This command can
be used to display Advanced Configuration and Power Interface (ACPI)
tables.

16.143 lsapm
============

This module provides support for the ‘lsapm’ command.  This command can
be used to display Advanced power management (APM) information.

16.144 lsdev
============

This module provides support for the ‘lsdev’ command.  This command can
be used on MIPS Advanced RISC Computing (ARC) platforms to display
devices.

16.145 lsefi
============

This module provides support for the ‘lsefi’ command.  This command can
be used on EFI platforms to display EFI handles.

16.146 lsefimmap
================

This module provides support for the ‘lsefimmap’ command.  This command
can be used on EFI platforms to display the EFI memory map.

16.147 lsefisystab
==================

This module provides support for the ‘lsefisystab’ command.  This
command can be used on EFI platforms to display the EFI system tables.

16.148 lsmmap
=============

This module provides support for the ‘lsmmap’ command.  This command can
be used to display the memory map provided by firmware.

16.149 lspci
============

This module provides support for the ‘lspci’ command.  This command can
be used to display the PCI / PCIe devices.

16.150 lssal
============

This module provides support for the ‘lsefisystab’ command.  This
command can be used on Itanium (IA-64) EFI platforms to display the EFI
System Abstraction Layer system table.

16.151 lsspd
============

This module provides support for the ‘lsspd’ command.  This command can
be used on MIPS Loongson platforms to display the DDR RAM Serial
Presence Detect (SPD) EEPROM data.

16.152 lsxen
============

This module provides support for the commands ‘xen_ls’ and ‘xen_cat’ on
Xen platforms to list Xen storage.

16.153 luks
===========

This module provides support for the Linux Unified Key Setup (LUKS)
(version 1) disk encryption / decryption protocol.

16.154 luks2
============

This module provides support for the Linux Unified Key Setup 2 (LUKS2)
disk encryption / decryption protocol.

16.155 lvm
==========

This module provides support for reading Logical Volume Management
"logical" disks.  For example, a single "logical" disk may be mapped to
span more than one physical disk.  This would be used when booting from
a LVM formatted disk as may be setup in Linux.

16.156 lzopio
=============

This module provides support for decompressing LZO / LZOP compressed
files / archives.

16.157 macbless
===============

This module provides support for commands ‘mactelbless’ and
‘macppcbless’ for "blessing" a bootloader on Intel / PPC based MACs
using the HFS or HFS+ file system.  On HFS / HFS+ - "blessing" makes a
file run as the bootloader.

16.158 macho
============

This module provides support for Mach Object (Mach-O) object /
executable files in GRUB often used in MacOS.

16.159 mda_text
===============

This module provides support for the Monochrome Display Adapter (MDA)
terminal output device.  MDA is a predecessor to VGA.

16.160 mdraid09
===============

This module provides support for handling Linux compatible "version 0.9"
software-based RAID disks in little-endian format.  The "version 0.9"
format was largely replaced around the year 2009 with the "version 1.x"
format (see mdraid1x_module for more information).

16.161 mdraid09_be
==================

This module provides support for handling Linux compatible "version 0.9"
software-based RAID disks in bid-endian format.  The "version 0.9"
format was largely replaced around the year 2009 with the "version 1.x"
format (see mdraid1x_module for more information).

16.162 mdraid1x
===============

This module provides support for handling Linux compatible "version 1.x"
software-based RAID disks.  This includes the current version used by
Linux at the time of writing.

16.163 memdisk
==============

This module provides support for a memdisk device.  A memdisk is a
memory mapped emulated disk.

16.164 memrw
============

This module provides support for commands ‘read_byte’, ‘read_word’,
‘read_dword’, ‘write_byte’, ‘write_word’, and ‘write_dword’ to read /
write data to physical memory (addresses).  The "read" commands accept
one parameter to specify the source address.  The "write" commands
require either two or three parameters, with the order: address, value,
<optional mask>.  Note: The commands provided by this module are not
allowed when lockdown is enforced (see Lockdown).

16.165 memtools
===============

This module provides support for GRUB development / debugging commands
‘lsmem’, ‘lsfreemem’, and ‘stress_big_allocs’.

16.166 minicmd
==============

This module provides support for a subset of commands for GRUB rescue
mode including: ‘cat’, ‘help’, ‘dump’, ‘rmmod’, ‘lsmod’, and ‘exit’.
The version of the commands in this module are similar to their
full-fledged counterparts implemented in other GRUB modules.  Note: The
‘dump’ command is not allowed when lockdown is enforced (see
Lockdown).

16.167 minix
============

This module provides support for the Minix filesystem, version 1.  Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.168 minix2
=============

This module provides support for the Minix filesystem, version 2.  Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.169 minix2_be
================

This module provides support for the Minix filesystem, version 2
big-endian.  Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.170 minix3
=============

This module provides support for the Minix filesystem, version 3.  Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.171 minix3_be
================

This module provides support for the Minix filesystem, version 3
big-endian.  Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.172 minix_be
===============

This module provides support for the Minix filesystem, version 1
big-endian.  Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.173 mmap
===========

This module provides support for mapping or unmapping devices or files
into memory as well as commands ‘badram’ and ‘cutmem’.  See badram
and cutmem.

16.174 morse
============

This module provides support for outputting terminal output via Morse
code to an audio speaker output.

16.175 mpi
==========

This module provides support for multi-precision-integers (MPIs) in
GRUB. MPIs are used by the crypto functions as many depend on
mathematics of large numbers.  This GRUB module is based on libgcrypt.

16.176 msdospart
================

This module provides support for modifying MSDOS formatted disk
partitions through the separate ‘parttool’ command.

16.177 mul_test
===============

This module is intended for performing a functional test of the
multiplication operations in GRUB.

16.178 multiboot
================

This module provides support for commands ‘multiboot’ and ‘module’ to
load a multiboot kernel and load a multiboot module, respectively.
See multiboot and module for more information.  This is for
loading data formatted per the GNU Multiboot specification.

16.179 multiboot2
=================

This module provides support for commands ‘multiboot2’ and ‘module2’ to
load a multiboot kernel and load a multiboot module, respectively.  This
is for loading data formatted per the GNU Multiboot specification.

16.180 nand
===========

This module provides support for accessing an IEEE-1275 compliant NAND
disk from GRUB.

16.181 nativedisk
=================

This module provides support for the ‘nativedisk’ command.  See
nativedisk for more information.

16.182 net
==========

This module provides support for networking protocols including ARP,
BOOTP, DNS, Ethernet, ICMPv6, ICMP, IP, TCP, and UDP. Support is
included for both IPv4 and IPv6.  This includes the following commands:
   • ‘net_bootp’ - see net_bootp

   • ‘net_dhcp’ - see net_dhcp

   • ‘net_get_dhcp_option’ - see net_get_dhcp_option

   • ‘net_nslookup’ - see net_nslookup

   • ‘net_add_dns’ - see net_add_dns

   • ‘net_del_dns’ - see net_del_dns

   • ‘net_ls_dns’ - see net_ls_dns

   • ‘net_add_addr’ - see net_add_addr

   • ‘net_ipv6_autoconf’ - see net_ipv6_autoconf

   • ‘net_del_addr’ - see net_del_addr

   • ‘net_add_route’ - see net_add_route

   • ‘net_del_route’ - see net_del_route

   • ‘net_set_vlan’ - see net_set_vlan

   • ‘net_ls_routes’ - see net_ls_routes

   • ‘net_ls_cards’ - see net_ls_cards

   • ‘net_ls_addr’ - see net_ls_addr

16.183 newc
===========

This module provides support for accessing a CPIO archive as a file
system from GRUB. This module is for the following newer variants of the
CPIO archive supported by GNU CPIO (but GNU CPIO defaults to the "bin"
format which is handled by the module cpio_module).

   These are the variants supported by this module:

   • "newc" - SVR4 portable format without CRC. GNU file utility will
     identify these as something like "ASCII cpio archive (SVR4 with no
     CRC)"

   • ‘crc’ - SVR4 portable format with CRC. GNU file utility will
     identify these as something like "ASCII cpio archive (SVR4 with
     CRC)"

16.184 nilfs2
=============

This module provides support for the New Implementation of Log
filesystem (nilfs2).  Note: This module is not allowed in lockdown mode,
see Lockdown for more information.

16.185 normal
=============

This module provides support for the normal mode in GRUB. See normal
for more information.

16.186 ntfs
===========

This module provides support for the New Technology File System (NTFS)
in GRUB. Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.187 ntfscomp
===============

This module provides support for compression with the New Technology
File System (NTFS) in GRUB. Note: This module is not allowed in lockdown
mode, see Lockdown for more information.

16.188 ntldr
============

This module provides support for the ‘ntldr’ command.  This is may be
used to boot a Windows boot loader such as NTLDR or BootMGR.

16.189 odc
==========

This module provides support for accessing a CPIO archive as a file
system from GRUB. This module is for "odc" variant of the CPIO archive
supported by GNU CPIO (but GNU CPIO defaults to the "bin" format which
is handled by the module cpio_module).

   GNU file utility will identify these as something like "ASCII cpio
archive (pre-SVR4 or odc)"

16.190 offsetio
===============

This module provides support for reading from a file / archive at
specified offsets in GRUB.

16.191 ofnet
============

This module provides support for the Open Firmware (IEEE-1275) network
device support in GRUB.

16.192 ohci
===========

This module provides support for the Open Host Controller Interface
(OHCI) for USB 1 / USB 1.1 support in GRUB.

16.193 part_acorn
=================

This module provides support for reading from disks partitioned with the
Acorn Disc Filing System (ADFS) used on RiscOS.

16.194 part_amiga
=================

This module provides support for reading from disks partitioned with the
Amiga partition table.

16.195 part_apple
=================

This module provides support for reading from disks partitioned with the
Macintosh partition table.

16.196 part_bsd
===============

This module provides support for reading from disks partitioned with BSD
style partition tables.

16.197 part_dfly
================

This module provides support for reading from disks partitioned with the
DragonFly BSD partition table.

16.198 part_dvh
===============

This module provides support for reading from disks partitioned with the
SGI Disk Volume Header partition table.

16.199 part_gpt
===============

This module provides support for reading from disks partitioned with the
GUID Partition Tables (GPT) partition table.

16.200 part_msdos
=================

This module provides support for reading from disks partitioned with the
MSDOS (Master Boot Record / MBR) style partition tables.

16.201 part_plan
================

This module provides support for reading from disk partitioned with the
Plan9 style partition table.

16.202 part_sun
===============

This module provides support for reading from disk partitioned with the
Sun style partition table.

16.203 part_sunpc
=================

This module provides support for reading from disk partitioned with the
Sun PC style partition table.

16.204 parttool
===============

This module provides support for the ‘parttool’ command.  See
parttool for more information.

16.205 password
===============

This module provides support for the ‘password’ command.  Please note
that this uses the password in plain text, if security is a concern
consider using password_pbkdf2_module instead.  See password
for more information.

16.206 password_pbkdf2
======================

This module provides support for the ‘password_pbkdf2’ command.  See
password_pbkdf2 for more information.

16.207 pata
===========

This module provides support for Parallel ATA (PATA) disk device
interfaces.

16.208 pbkdf2
=============

This module provides support for the Password-Based Key Derivation
Function 2 (PBKDF2) / PKCS#5 PBKDF2 as per RFC 2898.

16.209 pbkdf2_test
==================

This module is intended for performing a functional test of the PBKDF2
operation in GRUB.

16.210 pci
==========

This module provides support for generic Peripheral Component
Interconnect (PCI) bus in GRUB.

16.211 pcidump
==============

This module provides support for the ‘pcidump’ command in GRUB to dump
the PCI configuration registers in hexadecimal of a specified PCI device
(vendor / device ID) or by position on the bus.

16.212 pgp
==========

This module provides support for the commands: ‘verify_detached’,
‘trust’, ‘list_trusted’, ‘distrust’ associated with digital signature
checking via the "Open Pretty Good Privacy" (PGP) protocol / RFC 4880
using a provided public key.  This module also uses / sets environment
variable ‘check_signatures’.  See verify_detached, trust,
list_trusted, distrust, and check_signatures.

16.213 plainmount
=================

This module provides support for accessing / mounting partitions
encrypted by "cryptsetup" operating in "plain mode".  See plainmount
for more information.

16.214 plan9
============

This module provides support for the ‘plan9’ command to load a Plan9
kernel.

16.215 play
===========

This module provides support for the ‘play’ command to play a tune
through the PC speaker.  See play for more information.

16.216 png
==========

This module provides support for reading Portable Network Graphics (PNG)
image files in GRUB.

16.217 priority_queue
=====================

This module provides support for a priority queue function within GRUB
such as to support networking functions.

16.218 probe
============

This module provides support for the ‘probe’ command to retrieve device
information.  See probe for more information.

16.219 procfs
=============

This module provides support for a Proc File System to provide a file
system like interface to some GRUB internal data.

16.220 progress
===============

This module provides support for showing file loading progress to the
terminal.

16.221 pxe
==========

This module provides support for Preboot Execution Environment (PXE)
network boot services as a file system driver for other GRUB modules.

16.222 pxechain
===============

This module provides support for the ‘pxechainloader’ command to load
another bootloader by PXE.

16.223 raid5rec
===============

This module provides support for recovering from faulty RAID4/5 disk
arrays

16.224 raid6rec
===============

This module provides support for recovering from faulty RAID6 disk
arrays.

16.225 random
=============

This module provides support for library functions to get random data
via the hardware ACPI Power Management Timer and the TSC time source
(Timestamp Counter).

16.226 rdmsr
============

This module provides support for the ‘rdmsr’ command to read CPU Model
Specific Registers.  See rdmsr for more information.

16.227 read
===========

This module provides support for the ‘read’ command for getting user
input.  See read for more information.

16.228 reboot
=============

This module provides support for the ‘reboot’ command to reboot the
computer.  See reboot for more information.

16.229 regexp
=============

This module provides support for the ‘regexp’ command to check if a
regular expression matches a string.  This module also provides support
for the GRUB script wildcard translator.  See regexp for more
information.

16.230 reiserfs
===============

This module provides support for the ReiserFS File System in GRUB. Note:
This module is not allowed in lockdown mode, see Lockdown for more
information.

16.231 relocator
================

This module provides support for relocating the image / executable being
loaded to the expected memory location(s) and jumping to (invoking) the
executable.

16.232 romfs
============

This module provides support for the Read-Only Memory File System
(ROMFS). Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.233 scsi
===========

This module provides support for the Small Computer System Interface
(SCSI) protocol used for some types of disk communication include some
modern ones such as USB Mass Storage Devices supporting "USB Attached
SCSI" (UAS).

16.234 sdl
==========

This module provides support for Simple DirectMedia Layer (SDL) video /
image output from the grub-emu tool used to preview the GRUB menu from a
running Operating System such as Linux (useful to test GRUB menu
configuration changes without rebooting).  When available in the
compilation target environment, SDL2 will be used instead of SDL1.

16.235 search
=============

This module provides support for the ‘search’ command to search devices
by file, filesystem label, or filesystem UUID. See search for more
information.

16.236 search_fs_file
=====================

This module provides support for the ‘search.file’ command which is an
alias for the corresponding ‘search’ command.  See search for more
information.

16.237 search_fs_uuid
=====================

This module provides support for the ‘search.fs_uuid’ command which is
an alias for the corresponding ‘search’ command.  See search for
more information.

16.238 search_label
===================

This module provides support for the ‘search.fs_label’ command which is
an alias for the corresponding ‘search’ command.  See search for
more information.

16.239 sendkey
==============

This module provides support for the ‘sendkey’ command to send emulated
keystrokes.  See sendkey for more information.

16.240 serial
=============

This module provides support for the ‘serial’ command and associated
driver support for communication over a serial interface from GRUB.
See serial for more information.

16.241 setjmp
=============

This module provides support for the ‘setjmp’ and ‘longjmp’ functions
used within GRUB.

16.242 setjmp_test
==================

This module is intended for performing a functional test of the ‘setjmp’
and ‘longjmp’ functions in GRUB.

16.243 setpci
=============

This module provides support for the ‘setpci’ command to get / set
values from / to specified PCI / PCIe devices.

16.244 sfs
==========

This module provides support for the Amiga Smart File System (SFS) in
GRUB. Note: This module is not allowed in lockdown mode, see
Lockdown for more information.

16.245 shift_test
=================

This module is intended for performing a functional test of the bit-wise
shift operations in GRUB.

16.246 signature_test
=====================

This module is intended for performing a functional test of the digital
signature verification functions in GRUB.

16.247 sleep
============

This module provides support for the ‘sleep’ command to wait a specified
number of seconds in GRUB. See sleep for more information.

16.248 sleep_test
=================

This module is intended for performing a functional test of the sleep
function in GRUB.

16.249 smbios
=============

This module provides support for the ‘smbios’ command to retrieve SMBIOS
information in GRUB. See smbios for more information.

16.250 spkmodem
===============

This module provides support for outputting GRUB console information
over an audio output.  This output can be fed into another computer's
sound input and decoded using the ‘spkmodem_recv’ utility.  Note that
this will slow down GRUB's performance.

16.251 squash4
==============

This module provides support for the SquashFS compressed read-only file
system in GRUB.

16.252 strtoull_test
====================

This module is intended for performing a functional test of the strtoull
function in GRUB.

16.253 suspend
==============

This module provides support for the ‘suspend’ command in GRUB to return
to IEEE1275 prompt on "Open Firmware" systems.

16.254 syslinuxcfg
==================

This module provides support for commands ‘syslinux_source’,
‘syslinux_configfile’, ‘extract_syslinux_entries_source’, and
‘extract_syslinux_entries_configfile’ in GRUB. These commands can be
used to parse and display GRUB menu entries based on a Syslinux based
configuration (used for SYSLINUX, ISOLINUX, and PXELINUX). It can also
be used to execute the Syslinux loader from GRUB.

16.255 tar
==========

This module provides support for the GNU Tar and POSIX Tar file archives
as a file system in GRUB.

16.256 terminal
===============

This module provides support for the commands ‘terminal_input’ and
‘terminal_output’ in GRUB. See terminal_input and
terminal_output for more information.

16.257 terminfo
===============

This module provides support for the ‘terminfo’ command in GRUB to set
various terminal modes / options.  See terminfo for more
information.

16.258 test
===========

This module provides support for the commands ‘test’ and ‘[’.  These
commands can be used to evaluate (test) an expression.  See test for
more information.

16.259 test_blockarg
====================

This module is intended for performing a functional test of the "block"
command argument function in GRUB internal functions via a test command
‘test_blockarg’.

16.260 testload
===============

This module is intended for performing a functional test of some file
reading / seeking functions in GRUB internals via a test command
‘testload’.

16.261 testspeed
================

This module provides support for the ‘testspeed’ command to test and
print file read speed of a specified file.

16.262 tftp
===========

This module provides support for the Trivial File Transfer Protocol
(TFTP) for receiving files via the network to GRUB. TFTP may be used
along with PXE for network booting for example.

16.263 tga
==========

This module provides support for reading Truevision Graphics Adapter
(TGA) image files in GRUB.

16.264 time
===========

This module provides support for the ‘time’ command to measure the time
taken by a given command and output it to the terminal.

16.265 tpm
==========

This module provides support for interacting with a Trusted Platform
Module (TPM) with GRUB to perform Measured Boot.  See Measured Boot
for more information.

16.266 tr
=========

This module provides support for the ‘tr’ command in GRUB. This can be
used to translate characters in a string according to the provided
arguments.  For example this can be used to convert upper-case to
lower-case and visa-versa.

16.267 trig
===========

This module provides support for internal trig functions ‘grub_cos’ and
‘grub_sin’ using lookup based computation.  Currently these trig
functions are used by the gfxmenu circular progress bar.

16.268 true
===========

This module provides support for the commands ‘true’ and ‘false’.  See
true and false for more information.

16.269 truecrypt
================

This module provides support for the ‘truecrypt’ command.  This can be
used to load a Truecrypt ISO image.

16.270 ubootnet
===============

This module provides support for configuring network interfaces in GRUB
using information provided by a U-Boot bootloader.

16.271 udf
==========

This module provides support for the Universal Disk Format (UDF) used on
some newer optical disks.  Note: This module is not allowed in lockdown
mode, see Lockdown for more information.

16.272 ufs1
===========

This module provides support for the Unix File System version 1 in GRUB.
Note: This module is not allowed in lockdown mode, see Lockdown for
more information.

16.273 ufs1_be
==============

This module provides support for the Unix File System version 1
(big-endian) in GRUB. Note: This module is not allowed in lockdown mode,
see Lockdown for more information.

16.274 ufs2
===========

This module provides support for the Unix File System version 2 in GRUB.
Note: This module is not allowed in lockdown mode, see Lockdown for
more information.

16.275 uhci
===========

This module provides support for the Universal Host Controller Interface
(UHCI) for USB 1.x.

16.276 usb
==========

This module provides support for USB interfaces, USB hubs, and USB
transfers in GRUB.

16.277 usb_keyboard
===================

This module provides support for a USB keyboard in GRUB.

16.278 usbms
============

This module provides support for USB Mass Storage devices in GRUB.

16.279 usbserial_common
=======================

This module provides support for common operations needed to support USB
Serial port adapters in GRUB (to support a model / type specific USB to
serial adapter defined in another module).

16.280 usbserial_ftdi
=====================

This module provides support for USB to serial adapters with vendor ID
0x0403 and product ID 0x6001 (often associated with FTDI devices).

16.281 usbserial_pl2303
=======================

This module provides support for USB to serial adapters with vendor ID
0x067b and product ID 0x2303 (PL2303 USB to Serial adapter).

16.282 usbserial_usbdebug
=========================

This module provides support for debugging GRUB via a "USB 2.0 Debug
Cable".  The USB 2.0 specification includes a "USB2 Debug Device
Functional Specification" that this driver is intended to support for
GRUB. This may integrate with GDB server function in GRUB (see
gdb_module).

16.283 usbtest
==============

This module provides support for the ‘usb’ command in GRUB to test USB
functionality by iterating through all connected USB devices and
printing information for each to the terminal.

16.284 vbe
==========

This module provides support for the VESA BIOS Extension (VBE) Video
Driver in GRUB.

16.285 verifiers
================

This module is a built-in kernel module to provide a framework for GRUB
file verifiers and string verifiers.

16.286 vga
==========

This module provides support for the Video Graphics Array (VGA) Video
Driver in GRUB.

16.287 vga_text
===============

This module provides support for the Video Graphics Array (VGA) terminal
output device.

16.288 video
============

This module provides support for video output support functions within
GRUB.

16.289 video_bochs
==================

This module provides support for the Bochs PCI Video Driver (also known
as Bochs Graphics Adapter / BGA) in GRUB.

16.290 video_cirrus
===================

This module provides support for the Cirrus CLGD 5446 PCI Video Driver
(Cirrus Video) in GRUB.

16.291 video_colors
===================

This module provides support for interpreting named colors and parsing
RBG hexadecimal values.

16.292 video_fb
===============

This module provides support for video frame buffer (FB) support in
GRUB.

16.293 videoinfo
================

This module provides support for the ‘videoinfo’ command and (depending
on architecture) the ‘vbeinfo’ command.  See videoinfo for more
information.

16.294 videotest
================

This module provides support for the ‘videotest’ command and (depending
on architecture) the ‘vbetest’ to test the video subsystem in the
specified width and height.

16.295 videotest_checksum
=========================

This module is intended for performing a functional test of the video
functions in GRUB by displaying a test image and capturing a checksum.

16.296 wrmsr
============

This module provides support for the ‘wrmsr’ command to write to CPU
model-specific registers.  See wrmsr for more information.

16.297 xen_boot
===============

This module provides support for the commands ‘xen_hypervisor’ and
‘xen_module’ to load a XEN hypervisor and module respectively.

16.298 xfs
==========

This module provides support for the XFS file system in GRUB.

16.299 xnu
==========

This module provides support for the commands: ‘xnu_devprop_load’,
‘xnu_kernel’, ‘xnu_kernel64’, ‘xnu_mkext’, ‘xnu_kext’, ‘xnu_kextdir’,
‘xnu_ramdisk’, ‘xnu_splash’, and ‘xnu_resume’ (only for emulated
machine).  These commands support loading and interacting with a XNU
(MacOS / Apple) based system / kernel.

16.300 xnu_uuid
===============

This module provides support for the ‘xnu_uuid’ command to transform a
64-bit UUID to a format suitable for XNU.

16.301 xnu_uuid_test
====================

This module is intended for performing a functional test of the XNU UUID
conversion function.

16.302 xzio
===========

This module provides support for decompression of XZ compressed data.

16.303 zfs
==========

This module provides support for the ZFS file system in GRUB.

16.304 zfscrypt
===============

This module provides support for the ‘zfskey’ to import a decryption key
as well as decryption support for encrypted ZFS file systems.

16.305 zfsinfo
==============

This module provides support for the commands ‘zfsinfo’ to output ZFS
info about a device and ‘zfs-bootfs’ to output ZFS-BOOTFSOBJ or store it
into a variable.

16.306 zstd
===========

This module provides support for the Zstandard (zstd) decompression
algorithm in GRUB.

17 Available commands
*********************

In this chapter, we list all commands that are available in GRUB.

   Commands belong to different groups.  A few can only be used in the
global section of the configuration file (or "menu"); most of them can
be entered on the command-line and can be used either anywhere in the
menu or specifically in the menu entries.

   In rescue mode, only the ‘insmod’ (see insmod), ‘ls’ (see
ls), ‘set’ (see set), and ‘unset’ (see unset) commands are
normally available.  If you end up in rescue mode and do not know what
to do, then GRUB only offers a rescue shell.

17.1 Commands for the menu only
===============================

The semantics used in parsing the configuration file are the following:

   • The files _must_ be in plain-text format.

   • ‘#’ at the beginning of a line in a configuration file means it is
     only a comment.

   • Options are separated by spaces.

   • All numbers can be either decimal or hexadecimal.  A hexadecimal
     number must be preceded by ‘0x’, and is case-insensitive.

   These commands can only be used in the menu:

17.1.1 menuentry
----------------

 -- Command: menuentry TITLE [--class=class ...] [--users=users]
          [--unrestricted] [--hotkey=key] [--id=id] [ARG ...] { COMMAND;
          ... }
     This defines a GRUB menu entry named TITLE.  When this entry is
     selected from the menu, GRUB will set the CHOSEN environment
     variable to value of ‘--id’ if ‘--id’ is given, execute the list of
     commands given within braces, and if the last command in the list
     returned successfully and a kernel was loaded it will execute the
     ‘boot’ command.

     The ‘--class’ option may be used any number of times to group menu
     entries into classes.  Menu themes may display different classes
     using different styles.

     The ‘--users’ option grants specific users access to specific menu
     entries.  See Security.

     The ‘--unrestricted’ option grants all users access to specific
     menu entries.  See Security.

     The ‘--hotkey’ option associates a hotkey with a menu entry.  KEY
     may be a single letter, or one of the aliases ‘backspace’, ‘tab’,
     or ‘delete’.

     The ‘--id’ may be used to associate unique identifier with a menu
     entry.  ID is string of ASCII aphanumeric characters, underscore
     and hyphen and should not start with a digit.

     All other arguments including TITLE are passed as positional
     parameters when list of commands is executed with TITLE always
     assigned to ‘$1’.

17.1.2 submenu
--------------

 -- Command: submenu TITLE [--class=class ...] [--users=users]
          [--unrestricted] [--hotkey=key] [--id=id] { MENU ENTRIES ... }
     This defines a submenu.  An entry called TITLE will be added to the
     menu; when that entry is selected, a new menu will be displayed
     showing all the entries within this submenu.

     All options are the same as in the ‘menuentry’ command (see
     menuentry).

17.2 Various loader commands
============================

These commands are used to load necessary components to boot desired OS.
Many of the loader commands are not sufficiently documented.  The
following is a list of commands that could use more documentation:

   • ‘appleloader’ - Boot BIOS-based system.
   • ‘freedos’ - Load FreeDOS kernel.sys.
   • ‘kfreebsd_loadenv’ - Load FreeBSD env.
   • ‘kfreebsd_module_elf’ - Load FreeBSD kernel module (ELF).
   • ‘kfreebsd_module’ - Load FreeBSD kernel module.
   • ‘kfreebsd’ - Load kernel of FreeBSD.
   • ‘knetbsd_module_elf’ - Load NetBSD kernel module (ELF).
   • ‘knetbsd_module’ - Load NetBSD kernel module.
   • ‘knetbsd’ - Load kernel of NetBSD.
   • ‘kopenbsd’ - Load kernel of OpenBSD.
   • ‘kopenbsd_ramdisk’ - Load kOpenBSD ramdisk.
   • ‘legacy_initrd_nounzip’ - Simulate grub-legacy 'modulenounzip'
     command
   • ‘legacy_initrd’ - Simulate grub-legacy 'initrd' command
   • ‘legacy_kernel’ - Simulate grub-legacy 'kernel' command
   • ‘module2’ - Load a multiboot 2 module.
   • ‘module’ - Load a multiboot module.
   • ‘multiboot2’ - Load a multiboot 2 kernel.
   • ‘multiboot’ - Load a multiboot kernel.
   • ‘ntldr’ - Load NTLDR or BootMGR.
   • ‘plan9’ - Load Plan9 kernel.
   • ‘pxechainloader’ - Load a PXE image.
   • ‘truecrypt’ - Load Truecrypt ISO.
   • ‘xnu_kernel64’ - Load 64-bit XNU image.
   • ‘xnu_kernel’ - Load XNU image.
   • ‘xnu_kextdir’ - Load XNU extension directory.
   • ‘xnu_kext’ - Load XNU extension.
   • ‘xnu_mkext’ - Load XNU extension package.
   • ‘xnu_ramdisk’ - Load XNU ramdisk.  It will be available in OS as
     md0.
   • ‘xnu_resume’ - Load an image of hibernated XNU.
   • ‘xnu_splash’ - Load a splash image for XNU.

17.2.1 chainloader
------------------

 -- Command: chainloader [--force] file [args...]
     Load FILE as a chain-loader.  Like any other file loaded by the
     filesystem code, it can use the blocklist notation (see Block list syntax)
     to grab the first sector of the current partition
     with ‘+1’.  On EFI platforms, any arguments after FILE will be sent
     to the loaded image.

     If you specify the option ‘--force’, then load FILE forcibly,
     whether it has a correct signature or not.  This is required when
     you want to load a defective boot loader, such as SCO UnixWare 7.1.

17.2.2 initrd
-------------

 -- Command: initrd file [file ...]
     Load, in order, all initrds for a Linux kernel image, and set the
     appropriate parameters in the Linux setup area in memory.  This may
     only be used after the ‘linux’ command (see linux) has been
     run.  See GNU/Linux for more info on booting GNU/Linux.
     For more information on initrds see the GNU/Linux kernel
     documentation
     (https://docs.kernel.org/filesystems/ramfs-rootfs-initramfs.html).

     A new-style initrd (for kernels newer than 2.6) containing one file
     with leading path components can also be generated at run time.
     This can be done by prefixing an argument with ‘newc:’ followed by
     the path of the file in the new initrd, a ‘:’, and then the GRUB
     file path to the file data to be be included.

     For example:
          initrd newc:/etc/ssh/config:(hd0,2)/home/user/.ssh/config \
                 newc:/etc/ssh/ssh_host_rsa_key:/etc/ssh/ssh_host_rsa_key \
                 /boot/initrd.gz \
                 newc:/init:/home/user/init.fixed

     This command will generate two new-style initrds on the fly.  The
     first contains the path ‘/etc/ssh/config’ with the contents of
     ‘(hd0,2)/home/user/.ssh/config’ and the path
     ‘/etc/ssh/ssh_host_rsa_key’ with the contents of
     ‘/etc/ssh/ssh_host_rsa_key’ on the ROOT device.  Parent directory
     paths will automatically be generated as needed.  This first
     generated initrd will then have ‘/boot/initrd.gz’ concatenated
     after it.  Next, another new-style archive will be generated with
     the contents of ‘/home/user/init.fixed’ in the path ‘/init’ and
     appended to the previous concatenation.  Finally, the result will
     be sent to the kernel when booted.

     Keep in mind that paths that come later will take precedence.  So
     in the example above, the generated path ‘/init’ will overwrite any
     ‘/init’ in ‘/boot/initrd.gz’.  This can be useful when changing the
     main initrd is undesirable or difficult.

17.2.3 initrd16
---------------

 -- Command: initrd16 file [file ...]
     Load, in order, all initrds for a Linux kernel image to be booted
     in 16-bit mode, and set the appropriate parameters in the Linux
     setup area in memory.  This may only be used after the ‘linux16’
     command (see linux16) has been run.  See also GNU/Linux
     and the ‘initrd’ command (see initrd) for more details on
     arguments.

     This command is only available on the pc platform for x86 systems.

17.2.4 linux
------------

 -- Command: linux file ...
     Load a Linux kernel image from FILE.  The rest of the line is
     passed verbatim as the “kernel command-line”.  Any initrd must be
     reloaded after using this command (see initrd).

     On x86 systems, the kernel will be booted using the 32-bit boot
     protocol.  Note that this means that the ‘vga=’ boot option will
     not work; if you want to set a special video mode, you will need to
     use GRUB commands such as ‘set gfxpayload=1024x768’ or ‘set
     gfxpayload=keep’ (to keep the same mode as used in GRUB) instead.
     GRUB can automatically detect some uses of ‘vga=’ and translate
     them to appropriate settings of ‘gfxpayload’.  The ‘linux16’
     command (see linux16) avoids this restriction.

17.2.5 linux16
--------------

 -- Command: linux16 file ...
     Load a Linux kernel image from FILE in 16-bit mode.  The rest of
     the line is passed verbatim as the “kernel command-line”.  Any
     initrd must be reloaded after using this command (see
     initrd16).

     The kernel will be booted using the traditional 16-bit boot
     protocol.  As well as bypassing problems with ‘vga=’ described in
     linux, this permits booting some other programs that
     implement the Linux boot protocol for the sake of convenience.

     This command is only available on x86 systems.

17.2.6 xen_hypervisor
---------------------

 -- Command: xen_hypervisor file [arguments] ...
     Load a Xen hypervisor binary from FILE.  The rest of the line is
     passed verbatim as the “kernel command-line”.  Any other binaries
     must be reloaded after using this command.  This command is only
     available on AArch64 systems.

17.2.7 xen_module
-----------------

 -- Command: xen_module [--nounzip] file [arguments]
     Load a module for xen hypervisor at the booting process of xen.
     The rest of the line is passed verbatim as the module command line.
     Modules should be loaded in the following order: - dom0 kernel
     image - dom0 ramdisk if present - XSM policy if present This
     command is only available on AArch64 systems.

17.3 General commands
=====================

Commands usable anywhere in the menu and in the command-line.

17.3.1 serial
-------------

 -- Command: serial [--unit=unit] [--port=port] [--speed=speed]
          [--word=word] [--parity=parity] [--stop=stop]
     Initialize a serial device.  UNIT is a number in the range 0-3
     specifying which serial port to use; default is 0, which
     corresponds to the port often called COM1.

     PORT is the I/O port where the UART is to be found or, if prefixed
     with ‘mmio,’, the MMIO address of the UART. If specified it takes
     precedence over UNIT.

     Additionally, an MMIO address can be suffixed with:
        • ‘.b’ for bytes access (default)
        • ‘.w’ for 16-bit word access
        • ‘.l’ for 32-bit long word access or
        • ‘.q’ for 64-bit long long word access

     Also, PORT can be of the form ‘pci,XX:XX.X’ to indicate a serial
     device exposed on the PCI bus.

     SPEED is the transmission speed; default is 9600.  WORD and STOP
     are the number of data bits and stop bits.  Data bits must be in
     the range 5-8 and stop bits must be 1 or 2.  Default is 8 data bits
     and one stop bit.  PARITY is one of ‘no’, ‘odd’, ‘even’ and
     defaults to ‘no’.

     If passed no UNIT nor PORT, or if PORT is set to ‘auto’ then GRUB
     will attempt to use ACPI to automatically detect the system default
     serial port and its configuration.  If this information is not
     available, it will default to UNIT 0.

     The serial port is not used as a communication channel unless the
     ‘terminal_input’ or ‘terminal_output’ command is used (see
     terminal_input, terminal_output).

     Note, valid PORT values, excluding IO port addresses, can be found
     by listing terminals with ‘terminal_output’, selecting all names
     prefixed by ‘serial_’ and removing that prefix.

     Examples:
          serial --port=0x3f8 --speed=9600
          serial --port=mmio,fefb0000.l --speed=115200
          serial --port=pci,00:16.3 --speed=115200

     See also Serial terminal.

17.3.2 terminal_input
---------------------

 -- Command: terminal_input [--append|--remove] [terminal1] [terminal2]
          ...
     List or select an input terminal.

     With no arguments, list the active and available input terminals.

     With ‘--append’, add the named terminals to the list of active
     input terminals; any of these may be used to provide input to GRUB.

     With ‘--remove’, remove the named terminals from the active list.

     With no options but a list of terminal names, make only the listed
     terminal names active.

17.3.3 terminal_output
----------------------

 -- Command: terminal_output [--append|--remove] [terminal1] [terminal2]
          ...
     List or select an output terminal.

     With no arguments, list the active and available output terminals.

     With ‘--append’, add the named terminals to the list of active
     output terminals; all of these will receive output from GRUB.

     With ‘--remove’, remove the named terminals from the active list.

     With no options but a list of terminal names, make only the listed
     terminal names active.

17.3.4 terminfo
---------------

 -- Command: terminfo [-a|-u|-v] [-g WxH] [term] [type]
     Define the capabilities of your terminal by giving the name of an
     entry in the terminfo database, which should correspond roughly to
     a ‘TERM’ environment variable in Unix.

     The currently available terminal types are ‘vt100’, ‘vt100-color’,
     ‘ieee1275’, and ‘dumb’.  If you need other terminal types, please
     contact us to discuss the best way to include support for these in
     GRUB.

     The ‘-a’ (‘--ascii’), ‘-u’ (‘--utf8’), and ‘-v’ (‘--visual-utf8’)
     options control how non-ASCII text is displayed.  ‘-a’ specifies an
     ASCII-only terminal; ‘-u’ specifies logically-ordered UTF-8; and
     ‘-v’ specifies "visually-ordered UTF-8" (in other words, arranged
     such that a terminal emulator without bidirectional text support
     will display right-to-left text in the proper order; this is not
     really proper UTF-8, but a workaround).

     The ‘-g’ (‘--geometry’) can be used to specify terminal geometry.

     If no option or terminal type is specified, the current terminal
     type is printed.

17.4 Command-line commands
==========================

These commands are usable in the command-line and in menu entries.  If
you forget a command, you can run the command ‘help’ (see help).

17.4.1 [
--------

 -- Command: [ expression ]
     Alias for ‘test EXPRESSION’ (see test).

17.4.2 acpi
-----------

 -- Command: acpi [-1|-2] [--exclude=table1,...|--load-only=table1,...]
          [--oemid=id] [--oemtable=table] [--oemtablerev=rev]
          [--oemtablecreator=creator] [--oemtablecreatorrev=rev]
          [--no-ebda] filename ...
     Modern BIOS systems normally implement the Advanced Configuration
     and Power Interface (ACPI), and define various tables that describe
     the interface between an ACPI-compliant operating system and the
     firmware.  In some cases, the tables provided by default only work
     well with certain operating systems, and it may be necessary to
     replace some of them.

     Normally, this command will replace the Root System Description
     Pointer (RSDP) in the Extended BIOS Data Area to point to the new
     tables.  If the ‘--no-ebda’ option is used, the new tables will be
     known only to GRUB, but may be used by GRUB's EFI emulation.

     Note: The command is not allowed when lockdown is enforced (see
     Lockdown).  Otherwise an attacker can instruct the GRUB to load
     an SSDT table to overwrite the kernel lockdown configuration and
     later load and execute unsigned code.

17.4.3 authenticate
-------------------

 -- Command: authenticate [userlist]
     Check whether user is in USERLIST or listed in the value of
     variable ‘superusers’.  See superusers for valid user list
     format.  If ‘superusers’ is empty, this command returns true.
     See Security.

17.4.4 background_color
-----------------------

 -- Command: background_color color
     Set background color for active terminal.  For valid color
     specifications see Colors.  Background
     color can be changed only when using ‘gfxterm’ for terminal output.

     This command sets color of empty areas without text.  Text
     background color is controlled by environment variables
     COLOR_NORMAL, COLOR_HIGHLIGHT, MENU_COLOR_NORMAL,
     MENU_COLOR_HIGHLIGHT.  See Special environment variables.

17.4.5 background_image
-----------------------

 -- Command: background_image [[--mode stretch|normal] file]
     Load background image for active terminal from FILE.  Image is
     stretched to fill up entire screen unless option ‘--mode’ ‘normal’
     is given.  Without arguments remove currently loaded background
     image.  Background image can be changed only when using ‘gfxterm’
     for terminal output.

17.4.6 badram
-------------

 -- Command: badram addr,mask[,addr,mask...]
     Filter out bad RAM.

     This command notifies the memory manager that specified regions of
     RAM ought to be filtered out (usually, because they're damaged).
     This remains in effect after a payload kernel has been loaded by
     GRUB, as long as the loaded kernel obtains its memory map from
     GRUB. Kernels that support this include Linux, GNU Mach, the kernel
     of FreeBSD and Multiboot kernels in general.

     Syntax is the same as provided by the Memtest86+ utility
     (http://www.memtest.org/): a list of address/mask pairs.  Given a
     page-aligned address and a base address / mask pair, if all the
     bits of the page-aligned address that are enabled by the mask match
     with the base address, it means this page is to be filtered.  This
     syntax makes it easy to represent patterns that are often result of
     memory damage, due to physical distribution of memory cells.

     The command is similar to ‘cutmem’ command.

     Note: The command is not allowed when lockdown is enforced (see
     Lockdown).  This prevents removing EFI memory regions to
     potentially subvert the security mechanisms provided by the UEFI
     secure boot.

17.4.7 blocklist
----------------

 -- Command: blocklist file
     Print a block list (see Block list syntax) for FILE.

17.4.8 boot
-----------

 -- Command: boot
     Boot the OS or chain-loader which has been loaded.  Only necessary
     if running the fully interactive command-line (it is implicit at
     the end of a menu entry).

17.4.9 cat
----------

 -- Command: cat [--dos] file
     Display the contents of the file FILE.  This command may be useful
     to remind you of your OS's root partition:

          grub> cat /etc/fstab

     If the ‘--dos’ option is used, then carriage return / new line
     pairs will be displayed as a simple new line.  Otherwise, the
     carriage return will be displayed as a control character (‘<d>’) to
     make it easier to see when boot problems are caused by a file
     formatted using DOS-style line endings.

     Note: ‘cat’ can be used to view the contents of devices using the
     block list syntax (see Block list syntax).  However, it is not
     advised to view binary data because it will try to decode UTF-8
     strings, which can lead to some bytes missing or added in the
     output.  Instead, use the ‘hexdump’ command (see hexdump).

17.4.10 clear
-------------

 -- Command: clear
     Clear the screen.

17.4.11 cmosclean
-----------------

 -- Command: cmosclean byte:bit
     Clear value of bit in CMOS at location BYTE:BIT.  This command is
     available only on platforms that support CMOS.

17.4.12 cmosdump
----------------

 -- Dump: CMOS contents
     Dump full CMOS contents as hexadecimal values.  This command is
     available only on platforms that support CMOS.

17.4.13 cmostest
----------------

 -- Command: cmostest byte:bit
     Test value of bit in CMOS at location BYTE:BIT.  Exit status is
     zero if bit is set, non zero otherwise.  This command is available
     only on platforms that support CMOS.

17.4.14 cmp
-----------

 -- Command: cmp [-v] file1 file2
     Compare the file FILE1 with the file FILE2.  If they are completely
     identical, ‘$?’ will be set to 0.  Otherwise, if the files are not
     identical, ‘$?’ will be set to a nonzero value.

     By default nothing will be output.  If the ‘-v’ is used, verbose
     mode is enabled.  In this mode when when the files differ in size,
     print the sizes like this:

          Differ in size: 0x1234 [foo], 0x4321 [bar]

     If the sizes are equal but the bytes at an offset differ, then
     print the bytes like this:

          Differ at the offset 777: 0xbe [foo], 0xef [bar]

17.4.15 configfile
------------------

 -- Command: configfile file
     Load FILE as a configuration file.  If FILE defines any menu
     entries, then show a menu containing them immediately.  Any
     environment variable changes made by the commands in FILE will not
     be preserved after ‘configfile’ returns.

17.4.16 cpuid
-------------

 -- Command: cpuid [-l] [-p]
     Check for CPU features.  This command is only available on x86
     systems.

     With the ‘-l’ option, return true if the CPU supports long mode
     (64-bit).

     With the ‘-p’ option, return true if the CPU supports Physical
     Address Extension (PAE).

     If invoked without options, this command currently behaves as if it
     had been invoked with ‘-l’.  This may change in the future.

17.4.17 crc
-----------

 -- Command: crc arg ...
     Alias for ‘hashsum --hash crc32 arg ...’.  See command ‘hashsum’
     (see hashsum) for full description.

17.4.18 cryptocheck
-------------------

 -- Command: cryptocheck [ --quiet ] device
     Check if a given diskfilter device is backed by encrypted devices
     (see cryptomount for additional information).

     The command examines all backing devices, physical volumes, of a
     specified logical volume, like LVM2, and fails when at least one of
     them is unencrypted.

     The option ‘--quiet’ can be given to suppress the output.

17.4.19 cryptomount
-------------------

 -- Command: cryptomount [ [-p password] | [-k keyfile [-O keyoffset]
          [-S keysize] ] | [-P protector] ] [-H file] device|-u
          uuid|-a|-b
     Setup access to encrypted device.  A passphrase will be requested
     interactively, if neither the ‘-p’ nor ‘-k’ options are given.  The
     option ‘-p’ can be used to supply a passphrase (useful for
     scripts).  Alternatively the ‘-k’ option can be used to supply a
     keyfile with options ‘-O’ and ‘-S’ optionally supplying the offset
     and size, respectively, of the key data in the given key file.
     Besides the keyfile, the key can be stored in a key protector, and
     option ‘-P’ configures specific key protector, e.g.  tpm2, to
     retrieve the key from.  The ‘-H’ options can be used to supply
     cryptomount backends with an alternative header file (aka detached
     header).  Not all backends have headers nor support alternative
     header files (currently only LUKS1 and LUKS2 support them).
     Argument DEVICE configures specific grub device (see Naming convention);
     option ‘-u’ UUID configures device with specified
     UUID; option ‘-a’ configures all detected encrypted devices; option
     ‘-b’ configures all geli containers that have boot flag set.

     Devices are not allowed to be given as key files nor as detached
     header files.  However, this limitation can be worked around by
     using blocklist syntax.  So for instance, ‘(hd1,gpt2)’ can not be
     used, but ‘(hd1,gpt2)0+’ will achieve the desired result.

     GRUB supports devices encrypted using LUKS, LUKS2 and geli.  Note
     that necessary modules (LUKS, LUKS2 and GELI) have to be loaded
     manually before this command can be used.  For LUKS2 only the
     PBKDF2 key derivation function is supported, as Argon2 is not yet
     supported.

     Successfully decrypted disks are named as (cryptoX) and have
     increasing numeration suffix for each new decrypted disk.  If the
     encrypted disk hosts some higher level of abstraction (like LVM2 or
     MDRAID) it will be created under a separate device namespace in
     addition to the cryptodisk namespace.

     Support for plain encryption mode (plain dm-crypt) is provided via
     separate ‘see plainmount’ command.

     On the EFI platform, GRUB tries to erase master keys from memory
     when the cryptodisk module is unloaded or the command ‘exit’ is
     executed.  All secrets remain in memory when the command
     ‘chainloader’ is issued, because execution can return to GRUB on
     the EFI platform.

17.4.20 cutmem
--------------

 -- Command: cutmem from[K|M|G] to[K|M|G]
     Remove any memory regions in specified range.

     This command notifies the memory manager that specified regions of
     RAM ought to be filtered out.  This remains in effect after a
     payload kernel has been loaded by GRUB, as long as the loaded
     kernel obtains its memory map from GRUB. Kernels that support this
     include Linux, GNU Mach, the kernel of FreeBSD and Multiboot
     kernels in general.

     The command is similar to ‘badram’ command.

     Note: The command is not allowed when lockdown is enforced (see
     Lockdown).  This prevents removing EFI memory regions to
     potentially subvert the security mechanisms provided by the UEFI
     secure boot.

17.4.21 date
------------

 -- Command: date [[year-]month-day] [hour:minute[:second]]
     With no arguments, print the current date and time.

     Otherwise, take the current date and time, change any elements
     specified as arguments, and set the result as the new date and
     time.  For example, 'date 01-01' will set the current month and day
     to January 1, but leave the year, hour, minute, and second
     unchanged.

17.4.22 devicetree
------------------

 -- Command: devicetree file
     Load a device tree blob (.dtb) from a filesystem, for later use by
     a Linux kernel.  Does not perform merging with any device tree
     supplied by firmware, but rather replaces it completely.

     Note: The command is not allowed when lockdown is enforced (see
     Lockdown).  This is done to prevent subverting various security
     mechanisms.

17.4.23 distrust
----------------

 -- Command: distrust pubkey_id
     Remove public key PUBKEY_ID from GRUB's keyring of trusted keys.
     PUBKEY_ID is the last four bytes (eight hexadecimal digits) of the
     GPG v4 key id, which is also the output of ‘list_trusted’ (see
     list_trusted).  Outside of GRUB, the key id can be obtained using
     ‘gpg --fingerprint’).  These keys are used to validate signatures
     when environment variable ‘check_signatures’ is set to ‘enforce’
     (see check_signatures), and by some invocations of
     ‘verify_detached’ (see verify_detached).  See Using digital signatures,
     for more information.

17.4.24 drivemap
----------------

 -- Command: drivemap -l|-r|[-s] from_drive to_drive
     Without options, map the drive FROM_DRIVE to the drive TO_DRIVE.
     This is necessary when you chain-load some operating systems, such
     as DOS, if such an OS resides at a non-first drive.  For
     convenience, any partition suffix on the drive is ignored, so you
     can safely use ${root} as a drive specification.

     With the ‘-s’ option, perform the reverse mapping as well, swapping
     the two drives.

     With the ‘-l’ option, list the current mappings.

     With the ‘-r’ option, reset all mappings to the default values.

     For example:

          drivemap -s (hd0) (hd1)

     NOTE: Only available on i386-pc.

17.4.25 echo
------------

 -- Command: echo [-n] [-e] string ...
     Display the requested text and, unless the ‘-n’ option is used, a
     trailing new line.  If there is more than one string, they are
     separated by spaces in the output.  As usual in GRUB commands,
     variables may be substituted using ‘${var}’.

     The ‘-e’ option enables interpretation of backslash escapes.  The
     following sequences are recognised:

     ‘\\’
          backslash

     ‘\a’
          alert (BEL)

     ‘\c’
          suppress trailing new line

     ‘\f’
          form feed

     ‘\n’
          new line

     ‘\r’
          carriage return

     ‘\t’
          horizontal tab

     ‘\v’
          vertical tab

     When interpreting backslash escapes, backslash followed by any
     other character will print that character.

17.4.26 efitextmode
-------------------

 -- Command: efitextmode [min | max | <mode_num> | <cols> <rows>]
     When used with no arguments displays all available text output
     modes.  The set mode determines the columns and rows of the text
     display when in text mode.  An asterisk, ‘*’, will be at the end of
     the line of the currently set mode.

     If given a single parameter, it must be ‘min’, ‘max’, or a mode
     number given by the listing when run with no arguments.  These
     arguments set the mode to the minimum, maximum, and particular mode
     respectively.

     Otherwise, the command must be given two numerical arguments
     specifying the columns and rows of the desired mode.  Specifying a
     columns and rows combination that corresponds to no supported mode,
     will return error, but otherwise have no effect.

     By default GRUB will start in whatever mode the EFI firmware
     defaults to.  There are firmwares known to set up the default mode
     such that output behaves strangely, for example the cursor in the
     GRUB shell never reaches the bottom of the screen or, when typing
     characters at the prompt, characters from previous command output
     are overwritten.  Setting the mode may fix this.

     The EFI specification says that mode 0 must be available and have
     columns and rows of 80 and 25 respectively.  Mode 1 may be defined
     and if so must have columns and rows of 80 and 50 respectively.
     Any other modes may have columns and rows arbitrarily defined by
     the firmware.  This means that a mode with columns and rows of 100
     and 31 on one firmware may be a different mode number on a
     different firmware or not exist at all.  Likewise, mode number 2 on
     one firmware may have a different number of columns and rows than
     mode 2 on a different firmware.  So one should not rely on a
     particular mode number or a mode of a certain number of columns and
     rows existing on all firmwares, except for mode 0.

     Note: This command is only available on EFI platforms and is
     similar to EFI shell "mode" command.